unit uno_current_context;

interface

{$I uno_Common.inc}

uses
   uno_sal_config
  ,uno_rtl_ustring
  ,uno_sal_types;

	(** Gets the current task's context.
	 @attention
		Don't spread the returned interface around to other threads.  Every thread has its own
		current context.
		
	 @param ppCurrentContext inout param current context of type com.sun.star.uno.XCurrentContext
	 @param pEnvTypeName type name of returned interface's environment
	 @param pEnvContext context of returned interface's environment (commonly 0)
	  @return true, if context ref was transferred (even if null ref)	*)
	function uno_getCurrentContext(ppCurrentContext: PPointer; pEnvTypeName: prtl_uString; pEnvContext: Pointer): sal_Bool; cdecl;
	
	(** Sets the current task's context.
	 
	 @param pCurrentContext in param current context of type com.sun.star.uno.XCurrentContext
	 @param pEnvTypeName type name of interface's environment
	 @param pEnvContext context of interface's environment (commonly 0)
		@return true, if context ref was transferred (even if null ref)	*)
	function uno_setCurrentContext(pCurrentContext: Pointer; pEnvTypeName: prtl_uString; pEnvContext: Pointer): sal_Bool; cdecl; 

implementation

	function uno_getCurrentContext(ppCurrentContext: PPointer; pEnvTypeName: prtl_uString; pEnvContext: Pointer): sal_Bool; external cppu3LibraryName;
	function uno_setCurrentContext(pCurrentContext: Pointer; pEnvTypeName: prtl_uString; pEnvContext: Pointer): sal_Bool; external cppu3LibraryName; 

end.
