unit uno_dispatcher;

interface

{$I uno_common.inc}

uses
   uno_sal_types
  ,uno_rtl_ustring
  ,uno_any2
  ,uno_typelib_typedescription;

type
  p_uno_Interface = ^uno_Interface;
  pp_uno_Interface = ^p_uno_Interface;

{
   Function pointer declaration for the binary C uno dispatch function. Any pure out or return
    value will be constructed by the callee, iff no exception is signalled.
   If an exception is signalled, the any *ppException is properly constructed by the callee,
    otherwise the pointer *ppException is set to 0.
   An attribute get call is indicated by a non-null return pointer.

   @param pUnoI        uno interface the call is performed on
   @param pMemberType  member type description of a method or attribute
   @param pReturn      pointer to return value memory; pointer may be undefined if void method, null if attribute set call.
   @param pArgs        an array of pointers to arguments values.
                         (remark: the value of an interface reference stores a
                                  uno_interface *, so you get it by *(uno_Interface ** )pArgs[n])
   @param ppException pointer to pointer to unconstructed any to signal an exception.
}
    uno_DispatchMethod = procedure( pUnoI: p_uno_Interface;
                              pMemberType: p_typelib_TypeDescription;
                                  pReturn: Pointer;
                                    pArgs: Pointer;
                              ppException: PP_uno_Any ); cdecl;

  // The binary C uno interface description.
  _uno_Interface = record
    { Acquires uno interface.
        @param pInterface uno interface    }
    acquire: procedure( pInterface: p_uno_Interface ); cdecl;
    { Releases uno interface.
      @param pInterface uno interface    }
    release: procedure( pInterface: p_uno_Interface ); cdecl;
    // dispatch function
    pDispatcher: uno_DispatchMethod;
  end;
  uno_Interface = _uno_Interface;

implementation


end.
