unit uno_rtl_textcvt;

interface

{$I uno_common.inc}

uses
   uno_sal_config
  ,uno_sal_types
  ,uno_rtl_textenc;

type
{$IFDEF FPC}
{$PACKRECORDS C}
{$ENDIF}

  { Documentation about this file can be found at <http://udk.openoffice.org/cpp/man/spec/textconversion.html>.  }
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
     rtl_TextToUnicodeConverter = procedure;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
     rtl_TextToUnicodeContext = procedure;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  function rtl_createTextToUnicodeConverter(eTextEncoding:rtl_TextEncoding):rtl_TextToUnicodeConverter; cdecl;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  procedure rtl_destroyTextToUnicodeConverter(hConverter:rtl_TextToUnicodeConverter); cdecl;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  function rtl_createTextToUnicodeContext(hConverter:rtl_TextToUnicodeConverter):rtl_TextToUnicodeContext; cdecl;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  procedure rtl_destroyTextToUnicodeContext(hConverter:rtl_TextToUnicodeConverter; hContext:rtl_TextToUnicodeContext); cdecl;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  procedure rtl_resetTextToUnicodeContext(hConverter:rtl_TextToUnicodeConverter; hContext:rtl_TextToUnicodeContext); cdecl;
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_ERROR : sal_uInt32;
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_IGNORE : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_MAPTOPRIVATE : sal_uInt32;
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_DEFAULT : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_ERROR : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_IGNORE : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_DEFAULT : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_INVALID_ERROR : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_INVALID_IGNORE : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_INVALID_DEFAULT : sal_uInt32;
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_FLUSH : sal_uInt32;    

  const
     RTL_TEXTTOUNICODE_FLAGS_GLOBAL_SIGNATURE = $10000;     
  { Accept any global document signatures (for example, in UTF-8, a leading
         EF BB BF encoding the Byte Order Mark U+FEFF)  }
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_MASK : sal_uInt32;    
   { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_MASK : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_INVALID_MASK : sal_uInt32;
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_ERROR : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_SRCBUFFERTOSMALL : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_DESTBUFFERTOSMALL : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_UNDEFINED : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_MBUNDEFINED : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_INVALID : sal_uInt32;    
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
(* Const before type ignored *)
  function rtl_convertTextToUnicode(hConverter:rtl_TextToUnicodeConverter; hContext:rtl_TextToUnicodeContext; pSrcBuf:Psal_Char; nSrcBytes:sal_Size; pDestBuf:Psal_Unicode;
             nDestChars:sal_Size; nFlags:sal_uInt32; pInfo:Psal_uInt32; pSrcCvtBytes:Psal_Size):sal_Size; cdecl;

  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  type
     rtl_UnicodeToTextConverter = procedure;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
     rtl_UnicodeToTextContext = procedure;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  function rtl_createUnicodeToTextConverter(eTextEncoding:rtl_TextEncoding):rtl_UnicodeToTextConverter; cdecl;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html }
  procedure rtl_destroyUnicodeToTextConverter(hConverter:rtl_UnicodeToTextConverter); cdecl;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  function rtl_createUnicodeToTextContext(hConverter:rtl_UnicodeToTextConverter):rtl_UnicodeToTextContext; cdecl;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  procedure rtl_destroyUnicodeToTextContext(hConverter:rtl_UnicodeToTextConverter; hContext:rtl_UnicodeToTextContext); cdecl;
  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
  procedure rtl_resetUnicodeToTextContext(hConverter:rtl_UnicodeToTextConverter; hContext:rtl_UnicodeToTextContext); cdecl;
  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_ERROR : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_IGNORE : sal_uInt32;
  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_0 : sal_uInt32;    
  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_QUESTIONMARK : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_UNDERLINE : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_DEFAULT : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_ERROR : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_IGNORE : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_0 : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_QUESTIONMARK : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_UNDERLINE : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_DEFAULT : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_REPLACE : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_REPLACESTR : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_PRIVATE_MAPTO0 : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_NONSPACING_IGNORE : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_CONTROL_IGNORE : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_PRIVATE_IGNORE : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_NOCOMPOSITE : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_FLUSH : sal_uInt32;    

  const
     RTL_UNICODETOTEXT_FLAGS_GLOBAL_SIGNATURE = $10000;     
  { Write any global document signatures (for example, in UTF-8, a leading
         EF BB BF encoding the Byte Order Mark U+FEFF)  }
  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_MASK : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_MASK : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_ERROR : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_SRCBUFFERTOSMALL : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_DESTBUFFERTOSMALL : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_UNDEFINED : sal_uInt32;    

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_INVALID : sal_uInt32;    

  {* see http://udk.openoffice.org/cpp/man/spec/textconversion.html}
(* Const before type ignored *)
  function rtl_convertUnicodeToText(hConverter:rtl_UnicodeToTextConverter; hContext:rtl_UnicodeToTextContext; pSrcBuf:Psal_Unicode; nSrcChars:sal_Size; pDestBuf:Psal_Char; 
             nDestBytes:sal_Size; nFlags:sal_uInt32; pInfo:Psal_uInt32; pSrcCvtChars:Psal_Size):sal_Size; cdecl;

implementation

  function rtl_createTextToUnicodeConverter(eTextEncoding:rtl_TextEncoding):rtl_TextToUnicodeConverter; external sal3LibraryName;
  procedure rtl_destroyTextToUnicodeConverter(hConverter:rtl_TextToUnicodeConverter); external sal3LibraryName;
  function rtl_createTextToUnicodeContext(hConverter:rtl_TextToUnicodeConverter):rtl_TextToUnicodeContext; external sal3LibraryName;
  procedure rtl_destroyTextToUnicodeContext(hConverter:rtl_TextToUnicodeConverter; hContext:rtl_TextToUnicodeContext); external sal3LibraryName;
  procedure rtl_resetTextToUnicodeContext(hConverter:rtl_TextToUnicodeConverter; hContext:rtl_TextToUnicodeContext); external sal3LibraryName;
  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_ERROR : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_ERROR:=sal_uInt32($0001);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_IGNORE : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_IGNORE:=sal_uInt32($0002);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_MAPTOPRIVATE : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_MAPTOPRIVATE:=sal_uInt32($0003);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_DEFAULT : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_DEFAULT:=sal_uInt32($0004);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_ERROR : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_ERROR:=sal_uInt32($0010);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_IGNORE : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_IGNORE:=sal_uInt32($0020);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_DEFAULT : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_DEFAULT:=sal_uInt32($0030);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_INVALID_ERROR : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_INVALID_ERROR:=sal_uInt32($0100);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_INVALID_IGNORE : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_INVALID_IGNORE:=sal_uInt32($0200);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_INVALID_DEFAULT : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_INVALID_DEFAULT:=sal_uInt32($0300);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_FLUSH : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_FLUSH:=sal_uInt32($8000);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_MASK : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_MASK:=sal_uInt32($000F);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_MASK : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_MASK:=sal_uInt32($00F0);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_FLAGS_INVALID_MASK : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_FLAGS_INVALID_MASK:=sal_uInt32($0F00);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_ERROR : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_INFO_ERROR:=sal_uInt32($0001);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_SRCBUFFERTOSMALL : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_INFO_SRCBUFFERTOSMALL:=sal_uInt32($0002);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_DESTBUFFERTOSMALL : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_INFO_DESTBUFFERTOSMALL:=sal_uInt32($0004);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_UNDEFINED : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_INFO_UNDEFINED:=sal_uInt32($0008);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_MBUNDEFINED : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_INFO_MBUNDEFINED:=sal_uInt32($0010);
      end;

  { was #define dname def_expr }
  function RTL_TEXTTOUNICODE_INFO_INVALID : sal_uInt32;
      begin
         RTL_TEXTTOUNICODE_INFO_INVALID:=sal_uInt32($0020);
      end;

  function rtl_convertTextToUnicode(hConverter:rtl_TextToUnicodeConverter; hContext:rtl_TextToUnicodeContext; pSrcBuf:Psal_Char; nSrcBytes:sal_Size; pDestBuf:Psal_Unicode;
             nDestChars:sal_Size; nFlags:sal_uInt32; pInfo:Psal_uInt32; pSrcCvtBytes:Psal_Size):sal_Size; external sal3LibraryName;
  function rtl_createUnicodeToTextConverter(eTextEncoding:rtl_TextEncoding):rtl_UnicodeToTextConverter; external sal3LibraryName;
  procedure rtl_destroyUnicodeToTextConverter(hConverter:rtl_UnicodeToTextConverter); external sal3LibraryName;
  function rtl_createUnicodeToTextContext(hConverter:rtl_UnicodeToTextConverter):rtl_UnicodeToTextContext; external sal3LibraryName;
  procedure rtl_destroyUnicodeToTextContext(hConverter:rtl_UnicodeToTextConverter; hContext:rtl_UnicodeToTextContext); external sal3LibraryName;
  procedure rtl_resetUnicodeToTextContext(hConverter:rtl_UnicodeToTextConverter; hContext:rtl_UnicodeToTextContext); external sal3LibraryName;
  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_ERROR : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_UNDEFINED_ERROR:=sal_uInt32($0001);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_IGNORE : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_UNDEFINED_IGNORE:=sal_uInt32($0002);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_0 : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_UNDEFINED_0:=sal_uInt32($0003);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_QUESTIONMARK : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_UNDEFINED_QUESTIONMARK:=sal_uInt32($0004);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_UNDERLINE : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_UNDEFINED_UNDERLINE:=sal_uInt32($0005);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_DEFAULT : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_UNDEFINED_DEFAULT:=sal_uInt32($0006);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_ERROR : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_INVALID_ERROR:=sal_uInt32($0010);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_IGNORE : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_INVALID_IGNORE:=sal_uInt32($0020);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_0 : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_INVALID_0:=sal_uInt32($0030);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_QUESTIONMARK : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_INVALID_QUESTIONMARK:=sal_uInt32($0040);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_UNDERLINE : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_INVALID_UNDERLINE:=sal_uInt32($0050);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_DEFAULT : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_INVALID_DEFAULT:=sal_uInt32($0060);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_REPLACE : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_UNDEFINED_REPLACE:=sal_uInt32($0100);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_REPLACESTR : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_UNDEFINED_REPLACESTR:=sal_uInt32($0200);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_PRIVATE_MAPTO0 : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_PRIVATE_MAPTO0:=sal_uInt32($0400);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_NONSPACING_IGNORE : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_NONSPACING_IGNORE:=sal_uInt32($0800);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_CONTROL_IGNORE : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_CONTROL_IGNORE:=sal_uInt32($1000);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_PRIVATE_IGNORE : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_PRIVATE_IGNORE:=sal_uInt32($2000);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_NOCOMPOSITE : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_NOCOMPOSITE:=sal_uInt32($4000);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_FLUSH : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_FLUSH:=sal_uInt32($8000);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_UNDEFINED_MASK : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_UNDEFINED_MASK:=sal_uInt32($000F);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_FLAGS_INVALID_MASK : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_FLAGS_INVALID_MASK:=sal_uInt32($00F0);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_ERROR : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_INFO_ERROR:=sal_uInt32($0001);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_SRCBUFFERTOSMALL : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_INFO_SRCBUFFERTOSMALL:=sal_uInt32($0002);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_DESTBUFFERTOSMALL : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_INFO_DESTBUFFERTOSMALL:=sal_uInt32($0004);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_UNDEFINED : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_INFO_UNDEFINED:=sal_uInt32($0008);
      end;

  { was #define dname def_expr }
  function RTL_UNICODETOTEXT_INFO_INVALID : sal_uInt32;
      begin
         RTL_UNICODETOTEXT_INFO_INVALID:=sal_uInt32($0010);
      end;

  function rtl_convertUnicodeToText(hConverter:rtl_UnicodeToTextConverter; hContext:rtl_UnicodeToTextContext; pSrcBuf:Psal_Unicode; nSrcChars:sal_Size; pDestBuf:Psal_Char; 
             nDestBytes:sal_Size; nFlags:sal_uInt32; pInfo:Psal_uInt32; pSrcCvtChars:Psal_Size):sal_Size; external sal3LibraryName;
end.
