unit uno_rtl_ustring;

interface

{$I uno_common.inc}

uses
   uno_sal_config
  ,uno_sal_types
  ,uno_rtl_string
  ,uno_rtl_textenc;

Type

{$ALIGN 4}

  // The implementation of a Unicode string.
  //    @internal
  _rtl_uString = record
    refCount : sal_Int32;
    length : sal_Int32;
//    buffer : array[0..0] of sal_Unicode;
    buffer: Pointer;
  end;
  rtl_uString = _rtl_uString;

{$ALIGN 8}


//  Pchar  = ^char;
  Prtl_uString  = ^rtl_uString;
  PPrtl_uString  = ^Prtl_uString;

{$IFDEF FPC}
  {$PACKRECORDS C}
{$ENDIF}

  // Return the length of a string.
  //    The length is equal to the number of 16-bit Unicode characters in the
  //    string, without the terminating NUL character.
  //  @param str - a null-terminated string.
  //  @return - the length of the sequence of characters represented by this string,
  //    excluding the terminating NUL character.
  //  Const before type ignored
  function rtl_ustr_getLength(str: Psal_Unicode): sal_Int32; cdecl;

  // Compare two strings.
  //    The comparison is based on the numeric value of each character in the
  //      strings and returns a value indicating their relationship.  This function
  //      cannot be used for language-specific sorting.  Both strings must be
  //      null-terminated.
  //  @param first - the first null-terminated string to be compared.
  //  @param second - the second null-terminated string which is compared with the first one.
  //  @return - 0 if both strings are equal, a value less than 0 if the first string is
  //      less than the second string, and a value greater than 0 if the first
  //      string is greater than the second string.
  function rtl_ustr_compare(first: Psal_Unicode; second: Psal_Unicode): sal_Int32; cdecl;

  // Compare two strings.
  //      The comparison is based on the numeric value of each character in the
  //      strings and returns a value indicating their relationship.  This function
  //      cannot be used for language-specific sorting.
  //  @param first
  //      the first string to be compared.  Need not be null-terminated, but must be
  //      at least as long as the specified firstLen.
  //      @param firstLen
  //      the length of the first string.
  //  @param second
  //      the second string which is compared with the first one.  Need not be
  //      null-terminated, but must be at least as long as the specified secondLen.
  //  @param secondLen
  //      the length of the second string.
  //  @return
  //      0 if both strings are equal, a value less than 0 if the first string is
  //      less than the second string, and a value greater than 0 if the first
  //      string is greater than the second string.
  function rtl_ustr_compare_WithLength(first: Psal_Unicode; firstLen: sal_Int32; second: Psal_Unicode; secondLen: sal_Int32): sal_Int32; cdecl;

  // Compare two strings with a maximum count of characters.
  //      The comparison is based on the numeric value of each character in the
  //      strings and returns a value indicating their relationship.  This function
  //      cannot be used for language-specific sorting.
  //  @param first
  //      the first string to be compared.  Need not be null-terminated, but must be
  //      at least as long as the specified firstLen.
  //  @param firstLen
  //      the length of the first string.
  //  @param second
  //      the second string which is compared with the first one.  Need not be
  //      null-terminated, but must be at least as long as the specified secondLen.
  //  @param secondLen
  //      the length of the second string.
  //  @param shortenedLen
  //      the maximum number of characters to compare.  This length can be greater
  //      or smaller than the lengths of the two strings.
  //  @return
  //      0 if both substrings are equal, a value less than 0 if the first substring
  //      is less than the second substring, and a value greater than 0 if the first
  //      substring is greater than the second substring.
  function rtl_ustr_shortenedCompare_WithLength(first: Psal_Unicode; firstLen: sal_Int32;
                                               second: Psal_Unicode; secondLen: sal_Int32;
                                               shortenedLen: sal_Int32): sal_Int32; cdecl;

  // Compare two strings from back to front.
  //      The comparison is based on the numeric value of each character in the
  //      strings and returns a value indicating their relationship.  This function
  //      cannot be used for language-specific sorting.
  //  @param first
  //      the first string to be compared.  Need not be null-terminated, but must be
  //      at least as long as the specified firstLen.
  //  @param firstLen
  //      the length of the first string.
  //  @param second
  //      the second string which is compared with the first one.  Need not be
  //      null-terminated, but must be at least as long as the specified secondLen.
  //  @param secondLen
  //      the length of the second string.
  //  @return
  //      0 if both strings are equal, a value less than 0 if the first string
  //      compares less than the second string, and a value greater than 0 if the
  //      first string compares greater than the second string.
  function rtl_ustr_reverseCompare_WithLength(first: Psal_Unicode; firstLen: sal_Int32;
                                              second: Psal_Unicode; secondLen: sal_Int32): sal_Int32; cdecl;

  // Compare two strings from back to front for equality.
  //      The comparison is based on the numeric value of each character in the
  //      strings and returns 'true' if, ans only if, both strings are equal.
  //  	This function cannot be used for language-specific sorting.
  // @param first
  //      the first string to be compared.  Need not be null-terminated, but must be
  //      at least as long as the specified len.
  // @param second
  //      the second string which is compared with the first one.  Need not be
  //      null-terminated, but must be at least as long as the specified len.
  // @param len
  //      the length of both strings.
  // @return
  //      true if both strings are equal, false if they are not equal.
  function rtl_ustr_asciil_reverseEquals_WithLength(first: Psal_Unicode; second: Psal_Char;
                                                    len: sal_Int32): sal_Bool; cdecl;

  // Compare two strings, ignoring the case of ASCII characters.
  //      The comparison is based on the numeric value of each character in the
  //      strings and returns a value indicating their relationship.  Character
  //      values between 65 and 90 (ASCII A--Z) are interpreted as values between 97
  //      and 122 (ASCII a--z).  This function cannot be used for language-specific
  //      sorting.  Both strings must be null-terminated.
  // @param first
  //      the first null-terminated string to be compared.
  // @param second
  //      the second null-terminated string which is compared with the first one.
  // @return
  //      0 if both strings are equal, a value less than 0 if the first string is
  //      less than the second string, and a value greater than 0 if the first
  //      string is greater than the second string.
  function rtl_ustr_compareIgnoreAsciiCase(first: Psal_Unicode; second: Psal_Unicode): sal_Int32; cdecl;

  // Compare two strings, ignoring the case of ASCII characters.
  //      The comparison is based on the numeric value of each character in the
  //      strings and returns a value indicating their relationship.  Character
  //      values between 65 and 90 (ASCII A--Z) are interpreted as values between 97
  //     and 122 (ASCII a--z).  This function cannot be used for language-specific
  //      sorting.
  // @param first
  //      the first string to be compared.  Need not be null-terminated, but must be
  //      at least as long as the specified firstLen.
  // @param firstLen
  //      the length of the first string.
  // @param second
  //      the second string which is compared with the first one.  Need not be
  //      null-terminated, but must be at least as long as the specified secondLen.
  // @param secondLen
  //      the length of the second string.
  // @return
  //      0 if both strings are equal, a value less than 0 if the first string is
  //      less than the second string, and a value greater than 0 if the first
  //      string is greater than the second string.
  function rtl_ustr_compareIgnoreAsciiCase_WithLength(first: Psal_Unicode; firstLen: sal_Int32;
                                                     second: Psal_Unicode; secondLen: sal_Int32): sal_Int32; cdecl;

  {* Compare two strings with a maximum count of characters, ignoring the case
      of ASCII characters.
  
      The comparison is based on the numeric value of each character in the
      strings and returns a value indicating their relationship.  Character
      values between 65 and 90 (ASCII A--Z) are interpreted as values between 97
      and 122 (ASCII a--z).  This function cannot be used for language-specific
      sorting.
  
      @param first
      the first string to be compared.  Need not be null-terminated, but must be
      at least as long as the specified firstLen.
  
      @param firstLen
      the length of the first string.
  
      @param second
      the second string which is compared with the first one.  Need not be
      null-terminated, but must be at least as long as the specified secondLen.
  
      @param secondLen
      the length of the second string.
  
      @param shortenedLen
      the maximum number of characters to compare.  This length can be greater
      or smaller than the lengths of the two strings.
  
      @return
      0 if both substrings are equal, a value less than 0 if the first substring
      is less than the second substring, and a value greater than 0 if the first
      substring is greater than the second substring.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_shortenedCompareIgnoreAsciiCase_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Unicode; secondLen:sal_Int32; shortenedLen:sal_Int32):sal_Int32; cdecl;

  {* Compare two strings.
  
      The comparison is based on the numeric value of each character in the
      strings and returns a value indicating their relationship.  This function
      cannot be used for language-specific sorting.  Both strings must be
      null-terminated.
  
      Since this function is optimized for performance, the ASCII character
      values are not converted in any way.  The caller has to make sure that
      all ASCII characters are in the allowed range of 0 and 127, inclusive.
  
      @param first
      the first null-terminated string to be compared.
  
      @param second
      the second null-terminated ASCII string which is compared with the first
      one.
  
      @return
      0 if both substrings are equal, a value less than 0 if the first substring
      is less than the second substring, and a value greater than 0 if the first
      substring is greater than the second substring.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_ascii_compare(first:Psal_Unicode; second:Psal_Char):sal_Int32; cdecl;

  {* Compare two strings.
  
      The comparison is based on the numeric value of each character in the
      strings and returns a value indicating their relationship.  This function
      cannot be used for language-specific sorting.
  
      Since this function is optimized for performance, the ASCII character
      values are not converted in any way.  The caller has to make sure that
      all ASCII characters are in the allowed range of 0 and 127, inclusive.
  
      @param first
      the first string to be compared.  Need not be null-terminated, but must be
      at least as long as the specified firstLen.
  
      @param firstLen
      the length of the first string.
  
      @param second
      the second null-terminated ASCII string which is compared with the first
      one.
  
      @return
      0 if both substrings are equal, a value less than 0 if the first substring
      is less than the second substring, and a value greater than 0 if the first
      substring is greater than the second substring.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_ascii_compare_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char):sal_Int32; cdecl;

  {* Compare two strings with a maximum count of characters.
  
      The comparison is based on the numeric value of each character in the
      strings and returns a value indicating their relationship.  This function
      cannot be used for language-specific sorting.
  
      Since this function is optimized for performance, the ASCII character
      values are not converted in any way.  The caller has to make sure that
      all ASCII characters are in the allowed range of 0 and 127, inclusive.
  
      @param first
      the first string to be compared.  Need not be null-terminated, but must be
      at least as long as the specified firstLen.
  
      @param firstLen
      the length of the first string.
  
      @param second
      the second null-terminated ASCII string which is compared with the first
      one.
  
      @param shortenedLen
      the maximum number of characters to compare.  This length can be greater
      or smaller than the lengths of the two strings.
  
      @return
      0 if both substrings are equal, a value less than 0 if the first substring
      is less than the second substring, and a value greater than 0 if the first
      substring is greater than the second substring.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_ascii_shortenedCompare_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char; shortenedLen:sal_Int32):sal_Int32; cdecl;

  {* Compare two strings from back to front.
  
      The comparison is based on the numeric value of each character in the
      strings and returns a value indicating their relationship.  This function
      cannot be used for language-specific sorting.
  
      Since this function is optimized for performance, the ASCII character
      values are not converted in any way.  The caller has to make sure that
      all ASCII characters are in the allowed range of 0 and 127, inclusive.
  
      @param first
      the first string to be compared.  Need not be null-terminated, but must be
      at least as long as the specified firstLen.
  
      @param firstLen
      the length of the first string.
  
      @param second
      the second ASCII string which is compared with the first one.  Need not be
      null-terminated, but must be at least as long as the specified secondLen.
  
      @param secondLen
      the length of the second string.
  
      @return
      0 if both strings are equal, a value less than 0 if the first string
      compares less than the second string, and a value greater than 0 if the
      first string compares greater than the second string.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_asciil_reverseCompare_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char; secondLen:sal_Int32):sal_Int32; cdecl;

  {* Compare two strings, ignoring the case of ASCII characters.
  
      The comparison is based on the numeric value of each character in the
      strings and returns a value indicating their relationship.  Character
      values between 65 and 90 (ASCII A--Z) are interpreted as values between 97
      and 122 (ASCII a--z).  This function cannot be used for language-specific
      sorting.  Both strings must be null-terminated.
  
      Since this function is optimized for performance, the ASCII character
      values are not converted in any way.  The caller has to make sure that
      all ASCII characters are in the allowed range of 0 and 127, inclusive.
  
      @param first
      the first null-terminated string to be compared.
  
      @param second
      the second null-terminated ASCII string which is compared with the first
      one.
  
      @return
      0 if both strings are equal, a value less than 0 if the first string is
      less than the second string, and a value greater than 0 if the first
      string is greater than the second string.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_ascii_compareIgnoreAsciiCase(first:Psal_Unicode; second:Psal_Char):sal_Int32; cdecl;

  {* Compare two strings, ignoring the case of ASCII characters.
  
      The comparison is based on the numeric value of each character in the
      strings and returns a value indicating their relationship.  Character
      values between 65 and 90 (ASCII A--Z) are interpreted as values between 97
      and 122 (ASCII a--z).  This function cannot be used for language-specific
      sorting.
  
      Since this function is optimized for performance, the ASCII character
      values are not converted in any way.  The caller has to make sure that
      all ASCII characters are in the allowed range of 0 and 127, inclusive.
  
      @param first
      the first string to be compared.  Need not be null-terminated, but must be
      at least as long as the specified firstLen.
  
      @param firstLen
      the length of the first string.
  
      @param second
      the second null-terminated ASCII string which is compared with the first
      one.
  
      @return
      0 if both strings are equal, a value less than 0 if the first string is
      less than the second string, and a value greater than 0 if the first
      string is greater than the second string.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_ascii_compareIgnoreAsciiCase_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char):sal_Int32; cdecl;

  {* Compare two strings, ignoring the case of ASCII characters.
  
      The comparison is based on the numeric value of each character in the
      strings and returns a value indicating their relationship.  Character
      values between 65 and 90 (ASCII A--Z) are interpreted as values between 97
      and 122 (ASCII a--z).  This function cannot be used for language-specific
      sorting.
  
      Since this function is optimized for performance, the ASCII character
      values are not converted in any way.  The caller has to make sure that
      all ASCII characters are in the allowed range of 0 and 127, inclusive.
  
      @param first
      the first string to be compared.  Need not be null-terminated, but must be
      at least as long as the specified firstLen.
  
      @param firstLen
      the length of the first string.
  
      @param second
      the second string which is compared with the first one.  Need not be
      null-terminated, but must be at least as long as the specified secondLen.
  
      @param secondLen
      the length of the second string.
  
      @return
      0 if both strings are equal, a value less than 0 if the first string is
      less than the second string, and a value greater than 0 if the first
      string is greater than the second string.
    }
(* Const before declarator ignored *)
(* Const before declarator ignored *)
  function rtl_ustr_ascii_compareIgnoreAsciiCase_WithLengths(first:Psal_Unicode; firstLen:sal_Int32; second:Pchar; secondLen:sal_Int32):sal_Int32; cdecl;

  {* Compare two strings with a maximum count of characters, ignoring the case
      of ASCII characters.
  
      The comparison is based on the numeric value of each character in the
      strings and returns a value indicating their relationship.  Character
      values between 65 and 90 (ASCII A--Z) are interpreted as values between 97
      and 122 (ASCII a--z).  This function cannot be used for language-specific
      sorting.
  
      Since this function is optimized for performance, the ASCII character
      values are not converted in any way.  The caller has to make sure that
      all ASCII characters are in the allowed range of 0 and 127, inclusive.
  
      @param first
      the first string to be compared.  Need not be null-terminated, but must be
      at least as long as the specified firstLen.
  
      @param firstLen
      the length of the first string.
  
      @param second
      the second null-terminated ASCII string which is compared with the first
      one.
  
      @param shortenedLen
      the maximum number of characters to compare.  This length can be greater
      or smaller than the lengths of the two strings.
  
      @return
      0 if both substrings are equal, a value less than 0 if the first substring
      is less than the second substring, and a value greater than 0 if the first
      substring is greater than the second substring.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_ascii_shortenedCompareIgnoreAsciiCase_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char; shortenedLen:sal_Int32):sal_Int32; cdecl;

  {* Return a hash code for a string.
  
      It is not allowed to store the hash code persistently, because later
      versions could return other hash codes.  The string must be
      null-terminated.
  
      @param str
      a null-terminated string.
  
      @return
      a hash code for the given string.
    }
(* Const before type ignored *)
  function rtl_ustr_hashCode(str:Psal_Unicode):sal_Int32; cdecl;

  {* Return a hash code for a string.
  
      It is not allowed to store the hash code persistently, because later
      versions could return other hash codes.
  
      @param str
      a string.  Need not be null-terminated, but must be at least as long as
      the specified len.
  
      @param len
      the length of the string.
  
      @return
      a hash code for the given string.
    }
(* Const before type ignored *)
  function rtl_ustr_hashCode_WithLength(str:Psal_Unicode; len:sal_Int32):sal_Int32; cdecl;

  {* Search for the first occurrence of a character within a string.
  
      The string must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @param ch
      the character to be searched for.
  
      @return
      the index (starting at 0) of the first occurrence of the character in the
      string, or -1 if the character does not occur.
    }
(* Const before type ignored *)
  function rtl_ustr_indexOfChar(str:Psal_Unicode; ch:sal_Unicode):sal_Int32; cdecl;

  {* Search for the first occurrence of a character within a string.
  
      @param str
      a string.  Need not be null-terminated, but must be at least as long as
      the specified len.
  
      @param len
      the length of the string.
  
      @param ch
      the character to be searched for.
  
      @return
      the index (starting at 0) of the first occurrence of the character in the
      string, or -1 if the character does not occur.
    }
(* Const before type ignored *)
  function rtl_ustr_indexOfChar_WithLength(str:Psal_Unicode; len:sal_Int32; ch:sal_Unicode):sal_Int32; cdecl;

  {* Search for the last occurrence of a character within a string.
  
      The string must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @param ch
      the character to be searched for.
  
      @return
      the index (starting at 0) of the last occurrence of the character in the
      string, or -1 if the character does not occur.  The returned value is
      always smaller than the string length.
    }
(* Const before type ignored *)
  function rtl_ustr_lastIndexOfChar(str:Psal_Unicode; ch:sal_Unicode):sal_Int32; cdecl;

  {* Search for the last occurrence of a character within a string.
  
      @param str
      a string.  Need not be null-terminated, but must be at least as long as
      the specified len.

      @param len
      the length of the string.
  
      @param ch
      the character to be searched for.
  
      @return
      the index (starting at 0) of the last occurrence of the character in the
      string, or -1 if the character does not occur.  The returned value is
      always smaller than the string length.
    }
(* Const before type ignored *)
  function rtl_ustr_lastIndexOfChar_WithLength(str:Psal_Unicode; len:sal_Int32; ch:sal_Unicode):sal_Int32; cdecl;

  {* Search for the first occurrence of a substring within a string.
  
      If subStr is empty, or both str and subStr are empty, -1 is returned.
      Both strings must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @param subStr
      the null-terminated substring to be searched for.
  
      @return
      the index (starting at 0) of the first character of the first occurrence
      of the substring within the string, or -1 if the substring does not occur.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_indexOfStr(str:Psal_Unicode; subStr:Psal_Unicode):sal_Int32; cdecl;

  {* Search for the first occurrence of a substring within a string.
  
      If subStr is empty, or both str and subStr are empty, -1 is returned.
  
      @param str
      a string.  Need not be null-terminated, but must be at least as long as
      the specified len.
  
      @param len
      the length of the string.
  
      @param subStr
      the substring to be searched for.  Need not be null-terminated, but must
      be at least as long as the specified subLen.
  
      @param subLen
      the length of the substring.
  
      @return
      the index (starting at 0) of the first character of the first occurrence
      of the substring within the string, or -1 if the substring does not occur.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_indexOfStr_WithLength(str:Psal_Unicode; len:sal_Int32; subStr:Psal_Unicode; subLen:sal_Int32):sal_Int32; cdecl;

  {* Search for the last occurrence of a substring within a string.
  
      If subStr is empty, or both str and subStr are empty, -1 is returned.
      Both strings must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @param subStr
      the null-terminated substring to be searched for.
  
      @return
      the index (starting at 0) of the first character of the last occurrence
      of the substring within the string, or -1 if the substring does not occur.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_lastIndexOfStr(str:Psal_Unicode; subStr:Psal_Unicode):sal_Int32; cdecl;

  {* Search for the last occurrence of a substring within a string.
  
      If subStr is empty, or both str and subStr are empty, -1 is returned.
  
      @param str
      a string.  Need not be null-terminated, but must be at least as long as
      the specified len.
  
      @param len
      the length of the string.
  
      @param subStr
      the substring to be searched for.  Need not be null-terminated, but must
      be at least as long as the specified subLen.
  
      @param subLen
      the length of the substring.
  
      @return
      the index (starting at 0) of the first character of the first occurrence
      of the substring within the string, or -1 if the substring does not occur.
    }
(* Const before type ignored *)
(* Const before type ignored *)
  function rtl_ustr_lastIndexOfStr_WithLength(str:Psal_Unicode; len:sal_Int32; subStr:Psal_Unicode; subLen:sal_Int32):sal_Int32; cdecl;

  // Replace all occurrences of a single character within a string.
  //      If oldChar does not occur within str, then the string is not modified.
  //      The string must be null-terminated.
  // @param str
  //      a null-terminated string.
  // @param oldChar
  //      the old character.
  // @param newChar
  //      the new character.
  procedure rtl_ustr_replaceChar(var str: sal_Unicode; oldChar: sal_Unicode; newChar: sal_Unicode); cdecl;

  {* Replace all occurrences of a single character within a string.
  
      If oldChar does not occur within str, then the string is not modified.
  
      @param str
      a string.  Need not be null-terminated, but must be at least as long as
      the specified len.
  
      @param len
      the length of the string.
  
      @param oldChar
      the old character.
  
      @param newChar
      the new character.
    }
  procedure rtl_ustr_replaceChar_WithLength(var str: sal_Unicode; len:sal_Int32; oldChar:sal_Unicode; newChar:sal_Unicode); cdecl;

  {* Convert all ASCII uppercase letters to lowercase within a string.

      The characters with values between 65 and 90 (ASCII A--Z) are replaced
      with values between 97 and 122 (ASCII a--z).  The string must be
      null-terminated.
  
      @param str
      a null-terminated string.
    }
  procedure rtl_ustr_toAsciiLowerCase(var str: sal_Unicode); cdecl;

  {* Convert all ASCII uppercase letters to lowercase within a string.
  
      The characters with values between 65 and 90 (ASCII A--Z) are replaced
      with values between 97 and 122 (ASCII a--z).
  
      @param str
      a string.  Need not be null-terminated, but must be at least as long as
      the specified len.
  
      @param len
      the length of the string.
    }
  procedure rtl_ustr_toAsciiLowerCase_WithLength(var str: sal_Unicode; len:sal_Int32); cdecl;

  {* Convert all ASCII lowercase letters to uppercase within a string.
  
      The characters with values between 97 and 122 (ASCII a--z) are replaced
      with values between 65 and 90 (ASCII A--Z).  The string must be
      null-terminated.
  
      @param str
      a null-terminated string.
    }
  procedure rtl_ustr_toAsciiUpperCase(var str: sal_Unicode); cdecl;

  {* Convert all ASCII lowercase letters to uppercase within a string.
  
      The characters with values between 97 and 122 (ASCII a--z) are replaced
      with values between 65 and 90 (ASCII A--Z).
  
      @param str
      a string.  Need not be null-terminated, but must be at least as long as
      the specified len.
  
      @param len
      the length of the string.
    }
  procedure rtl_ustr_toAsciiUpperCase_WithLength(var str: sal_Unicode; len: sal_Int32); cdecl;

  {* Remove white space from both ends of a string.
  
      All characters with values less than or equal to 32 (the space character)
      are considered to be white space.  This function cannot be used for
      language-specific operations.  The string must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @return
      the new length of the string.
    }
  function rtl_ustr_trim(str:Psal_Unicode):sal_Int32; cdecl;

  {* Remove white space from both ends of the string.
  
      All characters with values less than or equal to 32 (the space character)
      are considered to be white space.  This function cannot be used for
      language-specific operations.  The string must be null-terminated.
  
      @param str
      a string.  Need not be null-terminated, but must be at least as long as
      the specified len.
  
      @param len
      the original length of the string.
  
      @return
      the new length of the string.
    }
  function rtl_ustr_trim_WithLength(str:Psal_Unicode; len:sal_Int32):sal_Int32; cdecl;

  {* Create the string representation of a boolean.
  
      If b is true, the buffer is filled with the string "true" and 5 is
      returned.  If b is false, the buffer is filled with the string "false" and
      6 is returned.  This function cannot be used for language-specific
      operations.
  
      @param str
      a buffer that is big enough to hold the result and the terminating NUL
      character.  You should use the RTL_USTR_MAX_VALUEOFBOOLEAN define to
      create a buffer that is big enough.
  
      @param b
      a boolean value.
  
      @return
      the length of the string.
    }
  function rtl_ustr_valueOfBoolean(str:Psal_Unicode; b:sal_Bool):sal_Int32; cdecl;


  const
     RTL_USTR_MAX_VALUEOFBOOLEAN = RTL_STR_MAX_VALUEOFBOOLEAN;     
  {* Create the string representation of a character.
  
      @param str
      a buffer that is big enough to hold the result and the terminating NUL
      character.  You should use the RTL_USTR_MAX_VALUEOFCHAR define to create a
      buffer that is big enough.
  
      @param ch
      a character value.
  
      @return
      the length of the string.
    }

  function rtl_ustr_valueOfChar(str:Psal_Unicode; ch:sal_Unicode):sal_Int32; cdecl;


  const
     RTL_USTR_MAX_VALUEOFCHAR = RTL_STR_MAX_VALUEOFCHAR;     
  {* Create the string representation of an integer.
  
      This function cannot be used for language-specific operations.
  
      @param str
      a buffer that is big enough to hold the result and the terminating NUL
      character.  You should use the RTL_USTR_MAX_VALUEOFINT32 define to create
      a buffer that is big enough.
  
      @param i
      an integer value.
  
      @param radix
      the radix.  Must be between RTL_USTR_MIN_RADIX (2) and RTL_USTR_MAX_RADIX
      (36), inclusive.
  
      @return
      the length of the string.
    }

  function rtl_ustr_valueOfInt32(str:Psal_Unicode; i:sal_Int32; radix:sal_Int16):sal_Int32; cdecl;


  const
     RTL_USTR_MIN_RADIX = RTL_STR_MIN_RADIX;     
     RTL_USTR_MAX_RADIX = RTL_STR_MAX_RADIX;     
     RTL_USTR_MAX_VALUEOFINT32 = RTL_STR_MAX_VALUEOFINT32;     
  {* Create the string representation of a long integer.
  
      This function cannot be used for language-specific operations.
  
      @param str
      a buffer that is big enough to hold the result and the terminating NUL
      character.  You should use the RTL_USTR_MAX_VALUEOFINT64 define to create
      a buffer that is big enough.
  
      @param l
      a long integer value.
  
      @param radix
      the radix.  Must be between RTL_USTR_MIN_RADIX (2) and RTL_USTR_MAX_RADIX
      (36), inclusive.
  
      @return
      the length of the string.
    }

  function rtl_ustr_valueOfInt64(str:Psal_Unicode; l:sal_Int64; radix:sal_Int16):sal_Int32; cdecl;


  const
     RTL_USTR_MAX_VALUEOFINT64 = RTL_STR_MAX_VALUEOFINT64;     
  {* Create the string representation of a float.
  
      This function cannot be used for language-specific conversion.
  
      @param str
      a buffer that is big enough to hold the result and the terminating NUL
      character.  You should use the RTL_USTR_MAX_VALUEOFFLOAT define to create
      a buffer that is big enough.
  
      @param f
      a float value.
  
      @return
      the length of the string.
    }

  function rtl_ustr_valueOfFloat(str:Psal_Unicode; f:double):sal_Int32; cdecl;


  const
     RTL_USTR_MAX_VALUEOFFLOAT = RTL_STR_MAX_VALUEOFFLOAT;     
  {* Create the string representation of a double.
  
      This function cannot be used for language-specific conversion.
  
      @param str
      a buffer that is big enough to hold the result and the terminating NUL
      character.  You should use the RTL_USTR_MAX_VALUEOFDOUBLE define to create
      a buffer that is big enough.
  
      @param d
      a double value.
  
      @return
      the length of the string.
    }

  function rtl_ustr_valueOfDouble(str:Psal_Unicode; d:double):sal_Int32; cdecl;


  const
     RTL_USTR_MAX_VALUEOFDOUBLE = RTL_STR_MAX_VALUEOFDOUBLE;     
  {* Interpret a string as a boolean.
  
      This function cannot be used for language-specific conversion.  The string
      must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @return
      true if the string is "1" or "true" in any ASCII case, false otherwise.
    }
(* Const before type ignored *)

  function rtl_ustr_toBoolean(str:Psal_Unicode):sal_Bool; cdecl;

  {* Interpret a string as an integer.
  
      This function cannot be used for language-specific conversion.  The string
      must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @param radix
      the radix.  Must be between RTL_USTR_MIN_RADIX (2) and RTL_USTR_MAX_RADIX
      (36), inclusive.
  
      @return
      the integer value represented by the string, or 0 if the string does not
      represent an integer.
    }
(* Const before type ignored *)
  function rtl_ustr_toInt32(str:Psal_Unicode; radix:sal_Int16):sal_Int32; cdecl;

  {* Interpret a string as a long integer.
  
      This function cannot be used for language-specific conversion.  The string
      must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @param radix
      the radix.  Must be between RTL_USTR_MIN_RADIX (2) and RTL_USTR_MAX_RADIX
      (36), inclusive.
  
      @return
      the long integer value represented by the string, or 0 if the string does
      not represent a long integer.
    }
(* Const before type ignored *)
  function rtl_ustr_toInt64(str:Psal_Unicode; radix:sal_Int16):sal_Int64; cdecl;

  {* Interpret a string as a float.
  
      This function cannot be used for language-specific conversion.  The string
      must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @return
      the float value represented by the string, or 0.0 if the string does not
      represent a float.
    }
(* Const before type ignored *)
  function rtl_ustr_toFloat(str:Psal_Unicode):double; cdecl;

  {* Interpret a string as a double.
  
      This function cannot be used for language-specific conversion.  The string
      must be null-terminated.
  
      @param str
      a null-terminated string.
  
      @return
      the float value represented by the string, or 0.0 if the string does not
      represent a double.
    }
(* Const before type ignored *)
  function rtl_ustr_toDouble(str: Psal_Unicode):double; cdecl;

 { -----------------------------------------------------------------------  }
  // Increment the reference count of a string.
  //  @param str - a string.
  procedure rtl_uString_acquire(str: Prtl_uString); cdecl;

  // Decrement the reference count of a string.
  //      If the count goes to zero than the string data is deleted.
  // @param str - a string.
  procedure rtl_uString_release(str: Prtl_uString); cdecl;

  // Allocate a new string containing no characters.
  //  @param newStr
  //      pointer to the new string.  The pointed-to data must be null or a valid
  //      string.
  procedure rtl_uString_new(var newStr: Prtl_uString); cdecl;

  // Allocate a new string containing space for a given number of characters.
  //      If len is greater than zero, the reference count of the new string will be
  //      1.  The values of all characters are set to 0 and the length of the string
  //      is 0.  This function does not handle out-of-memory conditions.
  // @param newStr
  //      pointer to the new string.  The pointed-to data must be null or a valid
  //      string.
  // @param len
  //      the number of characters.
  procedure rtl_uString_new_WithLength(var newStr: Prtl_uString; nLen: sal_Int32); cdecl;

  // Allocate a new string that contains a copy of another string.
  //      If the length of value is greater than zero, the reference count of the
  //      new string will be 1.  This function does not handle out-of-memory
  //      conditions.
  // @param newStr
  //      pointer to the new string.  The pointed-to data must be null or a valid
  //      string.
  // @param value - a valid string.
  procedure rtl_uString_newFromString(var newStr: Prtl_uString; value: Prtl_uString); cdecl;

  // Allocate a new string that contains a copy of a character array.
  //      If the length of value is greater than zero, the reference count of the
  //      new string will be 1.  This function does not handle out-of-memory
  //      conditions.
  // @param newStr
  //      pointer to the new string.  The pointed-to data must be null or a valid
  //      string.
  // @param value - a null-terminated character array.
  procedure rtl_uString_newFromStr(var newStr: Prtl_uString; value: Psal_Unicode); cdecl;

  // Allocate a new string that contains a copy of a character array.
  //      If the length of value is greater than zero, the reference count of the
  //      new string will be 1.  This function does not handle out-of-memory
  //      conditions.
  // @param newStr
  //      pointer to the new string.  The pointed-to data must be null or a valid
  //      string.
  // @param value
  //      a character array.  Need not be null-terminated, but must be at least as
  //      long as the specified len.
  // @param len - the length of the character array.
  procedure rtl_uString_newFromStr_WithLength(var newStr: Prtl_uString; value: Psal_Unicode; len: sal_Int32); cdecl;

  // Allocate a new string that contains a copy of a character array.
  //      If the length of value is greater than zero, the reference count of the
  //      new string will be 1.  This function does not handle out-of-memory
  //      conditions.
  //      Since this function is optimized for performance, the ASCII character
  //      values are not converted in any way.  The caller has to make sure that
  //      all ASCII characters are in the allowed range of 0 and 127, inclusive.
  // @param newStr
  //      pointer to the new string.  The pointed-to data must be null or a valid
  //      string.
  // @param value - a null-terminated ASCII character array.
  procedure rtl_uString_newFromAscii(var newStr: Prtl_uString; value: Psal_Char); cdecl;

  // Assign a new value to a string.
  //      First releases any value str might currently hold, then acquires
  //      rightValue.
  // @param str
  //      pointer to the string.  The pointed-to data must be null or a valid
  //      string.
  // @param rightValue
  //      a valid string.
  procedure rtl_uString_assign(var str: Prtl_uString; rightValue: Prtl_uString); cdecl;

  {* Return the length of a string.
  
      The length is equal to the number of characters in the string.
  
      @param str
      a valid string.
  
      @return
      the length of the string.
    }
  function rtl_uString_getLength(str:Prtl_uString):sal_Int32; cdecl;

  {* Return a pointer to the underlying character array of a string.
  
      @param str
      a valid string.
  
      @return
      a pointer to the null-terminated character array.
    }
  function rtl_uString_getStr(str:Prtl_uString):Psal_Unicode; cdecl;

  {* Create a new string that is the concatenation of two other strings.
  
      The new string does not necessarily have a reference count of 1 (in cases
      where one of the two other strings is empty), so it must not be modified
      without checking the reference count.  This function does not handle
      out-of-memory conditions.
  
      @param newStr
      pointer to the new string.  The pointed-to data must be null or a valid
      string.
  
      @param left
      a valid string.
  
      @param right
      a valid string.
    }
  procedure rtl_uString_newConcat(newStr:PPrtl_uString; left:Prtl_uString; right:Prtl_uString); cdecl;

  {* Create a new string by replacing a substring of another string.
  
      The new string results from replacing a number of characters (count),
      starting at the specified position (index) in the original string (str),
      with some new substring (subStr).  If subStr is null, than only a number
      of characters is deleted.
  
      The new string does not necessarily have a reference count of 1, so it
      must not be modified without checking the reference count.  This function
      does not handle out-of-memory conditions.
  
      @param newStr
      pointer to the new string.  The pointed-to data must be null or a valid
      string.
  
      @param str
      a valid string.
  
      @param index
      the index into str at which to start replacement.  Must be between 0 and
      the length of str, inclusive.
  
      @param count
      the number of charcters to remove.  Must not be negative, and the sum of
      index and count must not exceed the length of str.
  
      @param subStr
      either null or a valid string to be inserted.
    }
  procedure rtl_uString_newReplaceStrAt(newStr:PPrtl_uString; str:Prtl_uString; index:sal_Int32; count:sal_Int32; subStr:Prtl_uString); cdecl;

  {* Create a new string by replacing all occurrences of a single character
      within another string.
  
      The new string results from replacing all occurrences of oldChar in str
      with newChar.
  
      The new string does not necessarily have a reference count of 1 (in cases
      where oldChar does not occur in str), so it must not be modified without
      checking the reference count.  This function does not handle out-of-memory
      conditions.
  
      @param newStr
      pointer to the new string.  The pointed-to data must be null or a valid
      string.
  
      @param str
      a valid string.
  
      @param oldChar
      the old character.
  
      @param newChar
      the new character.
    }
  procedure rtl_uString_newReplace(newStr:PPrtl_uString; str:Prtl_uString; oldChar:sal_Unicode; newChar:sal_Unicode); cdecl;

  {* Create a new string by converting all ASCII uppercase letters to lowercase
      within another string.
  
      The new string results from replacing all characters with values between
      65 and 90 (ASCII A--Z) by values between 97 and 122 (ASCII a--z).
  
      This function cannot be used for language-specific conversion.  The new
      string does not necessarily have a reference count of 1 (in cases where
      no characters need to be converted), so it must not be modified without
      checking the reference count.  This function does not handle out-of-memory
      conditions.
  
      @param newStr
      pointer to the new string.  The pointed-to data must be null or a valid
      string.
  
      @param str
      a valid string.
    }
  procedure rtl_uString_newToAsciiLowerCase(newStr:PPrtl_uString; str:Prtl_uString); cdecl;

  {* Create a new string by converting all ASCII lowercase letters to uppercase
      within another string.
  
      The new string results from replacing all characters with values between
      97 and 122 (ASCII a--z) by values between 65 and 90 (ASCII A--Z).
  
      This function cannot be used for language-specific conversion.  The new
      string does not necessarily have a reference count of 1 (in cases where
      no characters need to be converted), so it must not be modified without
      checking the reference count.  This function does not handle out-of-memory
      conditions.
  
      @param newStr
      pointer to the new string.  The pointed-to data must be null or a valid
      string.
  
      @param str
      a valid string.
    }
  procedure rtl_uString_newToAsciiUpperCase(newStr:PPrtl_uString; str:Prtl_uString); cdecl;

  {* Create a new string by removing white space from both ends of another
      string.
  
      The new string results from removing all characters with values less than
      or equal to 32 (the space character) form both ends of str.
  
      This function cannot be used for language-specific conversion.  The new
      string does not necessarily have a reference count of 1 (in cases where
      no characters need to be removed), so it must not be modified without
      checking the reference count.  This function does not handle out-of-memory
      conditions.
  
      @param newStr
      pointer to the new string.  The pointed-to data must be null or a valid
      string.
  
      @param str
      a valid string.
    }
  procedure rtl_uString_newTrim(newStr:PPrtl_uString; str:Prtl_uString); cdecl;

  {* Create a new string by extracting a single token from another string.
  
      Starting at index, the token's next token is searched for.  If there is no
      such token, the result is an empty string.  Otherwise, all characters from
      the start of that token and up to, but not including the next occurrence
      of cTok make up the resulting token.  The return value is the position of
      the next token, or -1 if no more tokens follow.
  
      Example code could look like
        rtl_uString * pToken = NULL;
        sal_Int32 nIndex = 0;
        do
        
            ...
            nIndex = rtl_uString_getToken(&pToken, pStr, 0, ';', nIndex);
            ...
        
        while (nIndex >= 0);
  
      The new string does not necessarily have a reference count of 1, so it
      must not be modified without checking the reference count.  This function
      does not handle out-of-memory conditions.
  
      @param newStr
      pointer to the new string.  The pointed-to data must be null or a valid
      string.  If either token or index is negative, an empty token is stored in
      newStr (and -1 is returned).
  
      @param str
      a valid string.
  
      @param token
      the number of the token to return, starting at index.
  
      @param cTok
      the character that seperates the tokens.
  
      @param index
      the position at which searching for the token starts.  Must not be greater
      than the length of str.
  
      @return
      the index of the next token, or -1 if no more tokens follow.
    }
  function rtl_uString_getToken(newStr:PPrtl_uString; str:Prtl_uString; token:sal_Int32; cTok:sal_Unicode; index:sal_Int32):sal_Int32; cdecl;

  { =======================================================================  }
  {* Supply an ASCII string literal together with its length and text encoding.
  
      This macro can be used to compute (some of) the arguments in function calls
      like rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("foo")).
  
      @param constAsciiStr
      must be an expression of type "(possibly cv-qualified reference to) array of
      (possibly cv-qualified) char."  Each element of the referenced array must
      represent an ASCII value in the range 0x00--0x7F.  The last element of the
      referenced array is not considered part of the represented ASCII string, and
      its value should be 0x00.  Depending on where this macro is used, the nature
      of the supplied expression might be further restricted.
   }
(* error
#define RTL_CONSTASCII_USTRINGPARAM( constAsciiStr ) constAsciiStr, ((sal_Int32)(sizeof(constAsciiStr)-1)), RTL_TEXTENCODING_ASCII_US
in define line 1389 *)
    { =======================================================================  }
    { predefined constants for String-Conversion  }

{    const
       OSTRING_TO_OUSTRING_CVTFLAGS = (RTL_TEXTTOUNICODE_FLAGS_UNDEFINED_MAPTOPRIVATE or
                                       RTL_TEXTTOUNICODE_FLAGS_MBUNDEFINED_DEFAULT) or
                                       RTL_TEXTTOUNICODE_FLAGS_INVALID_DEFAULT;
}
    { -----------------------------------------------------------------------  }
    {* Create a new Unicode string by converting a byte string, using a specific
        text encoding.
    
        The lengths of the byte string and the Unicode string may differ (e.g.,
        for double-byte encodings, UTF-7, UTF-8).
    
        If the length of the byte string is greater than zero, the reference count
        of the new string will be 1.
    
        If an out-of-memory condition occurs, newStr will point to a null pointer
        upon return.
    
        @param newStr
        pointer to the new string.  The pointed-to data must be null or a valid
        string.
    
        @param str
        a byte character array.  Need not be null-terminated, but must be at
        least as long as the specified len.
    
        @param len
        the length of the byte character array.
    
        @param encoding
        the text encoding to use for conversion.
    
        @param convertFlags
        flags which control the conversion.  Either use
        OSTRING_TO_OUSTRING_CVTFLAGS, or see
        <http://udk.openoffice.org/cpp/man/spec/textconversion.html> for more
        details.
      }
(* Const before type ignored *)

    procedure rtl_string2UString(newStr:PPrtl_uString; str:Psal_Char; len:sal_Int32; encoding:rtl_TextEncoding; convertFlags:sal_uInt32); cdecl;

implementation

  function rtl_ustr_getLength(str:Psal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_compare(first:Psal_Unicode; second:Psal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_compare_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Unicode; secondLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_shortenedCompare_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Unicode; secondLen:sal_Int32; shortenedLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_reverseCompare_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Unicode; secondLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_asciil_reverseEquals_WithLength(first:Psal_Unicode; second:Psal_Char; len:sal_Int32):sal_Bool; external sal3LibraryName;
  function rtl_ustr_compareIgnoreAsciiCase(first:Psal_Unicode; second:Psal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_compareIgnoreAsciiCase_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Unicode; secondLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_shortenedCompareIgnoreAsciiCase_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Unicode; secondLen:sal_Int32; shortenedLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_ascii_compare(first: Psal_Unicode; second:Psal_Char):sal_Int32; external sal3LibraryName;
  function rtl_ustr_ascii_compare_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char):sal_Int32; external sal3LibraryName;
  function rtl_ustr_ascii_shortenedCompare_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char; shortenedLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_asciil_reverseCompare_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char; secondLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_ascii_compareIgnoreAsciiCase(first:Psal_Unicode; second:Psal_Char):sal_Int32; external sal3LibraryName;
  function rtl_ustr_ascii_compareIgnoreAsciiCase_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char):sal_Int32; external sal3LibraryName;
  function rtl_ustr_ascii_compareIgnoreAsciiCase_WithLengths(first:Psal_Unicode; firstLen:sal_Int32; second:Pchar; secondLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_ascii_shortenedCompareIgnoreAsciiCase_WithLength(first:Psal_Unicode; firstLen:sal_Int32; second:Psal_Char; shortenedLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_hashCode(str:Psal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_hashCode_WithLength(str:Psal_Unicode; len:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_indexOfChar(str:Psal_Unicode; ch:sal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_indexOfChar_WithLength(str:Psal_Unicode; len:sal_Int32; ch:sal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_lastIndexOfChar(str:Psal_Unicode; ch:sal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_lastIndexOfChar_WithLength(str:Psal_Unicode; len:sal_Int32; ch:sal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_indexOfStr(str:Psal_Unicode; subStr:Psal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_indexOfStr_WithLength(str:Psal_Unicode; len:sal_Int32; subStr:Psal_Unicode; subLen:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_lastIndexOfStr(str:Psal_Unicode; subStr:Psal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_lastIndexOfStr_WithLength(str:Psal_Unicode; len:sal_Int32; subStr:Psal_Unicode; subLen:sal_Int32):sal_Int32; external sal3LibraryName;

  procedure rtl_ustr_replaceChar(var str: sal_Unicode; oldChar:sal_Unicode; newChar:sal_Unicode); external sal3LibraryName;
  procedure rtl_ustr_replaceChar_WithLength(var str: sal_Unicode; len:sal_Int32; oldChar:sal_Unicode; newChar:sal_Unicode); external sal3LibraryName;
  procedure rtl_ustr_toAsciiLowerCase(var str: sal_Unicode); external sal3LibraryName;
  procedure rtl_ustr_toAsciiLowerCase_WithLength(var str: sal_Unicode; len: sal_Int32); external sal3LibraryName;
  procedure rtl_ustr_toAsciiUpperCase(var str: sal_Unicode); external sal3LibraryName;
  procedure rtl_ustr_toAsciiUpperCase_WithLength(var str: sal_Unicode; len: sal_Int32); external sal3LibraryName;

  function rtl_ustr_trim(str:Psal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_trim_WithLength(str:Psal_Unicode; len:sal_Int32):sal_Int32; external sal3LibraryName;
  function rtl_ustr_valueOfBoolean(str:Psal_Unicode; b:sal_Bool):sal_Int32; external sal3LibraryName;
  function rtl_ustr_valueOfChar(str:Psal_Unicode; ch:sal_Unicode):sal_Int32; external sal3LibraryName;
  function rtl_ustr_valueOfInt32(str:Psal_Unicode; i:sal_Int32; radix:sal_Int16):sal_Int32; external sal3LibraryName;
  function rtl_ustr_valueOfInt64(str:Psal_Unicode; l:sal_Int64; radix:sal_Int16):sal_Int32; external sal3LibraryName;
  function rtl_ustr_valueOfFloat(str:Psal_Unicode; f:double):sal_Int32; external sal3LibraryName;
  function rtl_ustr_valueOfDouble(str:Psal_Unicode; d:double):sal_Int32; external sal3LibraryName;
  function rtl_ustr_toBoolean(str:Psal_Unicode):sal_Bool; external sal3LibraryName;
  function rtl_ustr_toInt32(str:Psal_Unicode; radix:sal_Int16):sal_Int32; external sal3LibraryName;
  function rtl_ustr_toInt64(str:Psal_Unicode; radix:sal_Int16):sal_Int64; external sal3LibraryName;
  function rtl_ustr_toFloat(str:Psal_Unicode):double; external sal3LibraryName;
  function rtl_ustr_toDouble(str:Psal_Unicode):double; external sal3LibraryName;

  procedure rtl_uString_acquire(str: Prtl_uString); external sal3LibraryName;
  procedure rtl_uString_release(str: Prtl_uString); external sal3LibraryName;
  procedure rtl_uString_new(var newStr: Prtl_uString); external sal3LibraryName;
  procedure rtl_uString_new_WithLength(var newStr: Prtl_uString; nLen:sal_Int32); external sal3LibraryName;
  procedure rtl_uString_newFromString(var newStr: Prtl_uString; value:Prtl_uString); external sal3LibraryName;
  procedure rtl_uString_newFromStr(var newStr: Prtl_uString; value:Psal_Unicode); external sal3LibraryName;
  procedure rtl_uString_newFromStr_WithLength(var newStr: Prtl_uString; value:Psal_Unicode; len:sal_Int32); external sal3LibraryName;
  procedure rtl_uString_newFromAscii(var newStr: Prtl_uString; value: Psal_Char); external sal3LibraryName;
  procedure rtl_uString_assign(var str: Prtl_uString; rightValue:Prtl_uString); external sal3LibraryName;

  function rtl_uString_getLength(str:Prtl_uString):sal_Int32; external sal3LibraryName;
  function rtl_uString_getStr(str:Prtl_uString):Psal_Unicode; external sal3LibraryName;
  procedure rtl_uString_newConcat(newStr:PPrtl_uString; left:Prtl_uString; right:Prtl_uString); external sal3LibraryName;
  procedure rtl_uString_newReplaceStrAt(newStr:PPrtl_uString; str:Prtl_uString; index:sal_Int32; count:sal_Int32; subStr:Prtl_uString); external sal3LibraryName;
  procedure rtl_uString_newReplace(newStr:PPrtl_uString; str:Prtl_uString; oldChar:sal_Unicode; newChar:sal_Unicode); external sal3LibraryName;
  procedure rtl_uString_newToAsciiLowerCase(newStr:PPrtl_uString; str:Prtl_uString); external sal3LibraryName;
  procedure rtl_uString_newToAsciiUpperCase(newStr:PPrtl_uString; str:Prtl_uString); external sal3LibraryName;
  procedure rtl_uString_newTrim(newStr:PPrtl_uString; str:Prtl_uString); external sal3LibraryName;
  function rtl_uString_getToken(newStr:PPrtl_uString; str:Prtl_uString; token:sal_Int32; cTok:sal_Unicode; index:sal_Int32):sal_Int32; external sal3LibraryName;
  procedure rtl_string2UString(newStr:PPrtl_uString; str:Psal_Char; len:sal_Int32; encoding:rtl_TextEncoding; convertFlags:sal_uInt32); external sal3LibraryName;

end.
