unit uno_sal_config;

interface

{$I uno_common.inc}

{$if defined(SAL_W32)}
const
  SAL_DLLEXTENSION = '.dll';
  SAL_PRGEXTENSION = '.exe';
  SAL_PATHSEPARATOR = ';';
  SAL_PATHDELIMITER = '\\';

  sal3LibraryName = 'sal3.dll';
  cppu3LibraryName = 'cppu3.dll';
{$ifend}

{$if defined(SOLARIS) or defined(LINUX) or defined(NETBSD) or defined(FREEBSD) or defined(SCO) or defined(IRIX)}
const
  SAL_DLLEXTENSION = '.so';
  SAL_DLLPREFIX = 'lib';
  SAL_PRGEXTENSION = '.bin';
  SAL_PATHSEPARATOR = ':';
  SAL_PATHDELIMITER = '/';

  sal3LibraryName = 'libuno_sal.so.3';
  cppu3LibraryName = 'libuno_cppu.so.3';
{$ifend}

{$ifdef MACOSX}
const
  SAL_DLLEXTENSION = '.dylib';
  SAL_DLLPREFIX = 'lib';
  SAL_PRGEXTENSION = '.bin';
  SAL_PATHSEPARATOR = ':';
  SAL_PATHDELIMITER = '/';
{$endif}

{$ifdef HPUX}
const
  SAL_DLLEXTENSION = '.sl';
  SAL_DLLPREFIX = 'lib';
  SAL_PRGEXTENSION = '.bin';
{$endif}

function SAL_CONFIGFILE_(name: String): String;
function SAL_SYSCONFIGFILE_(name: String): String;

implementation

{SAL_CONFIGFILE( name ) name ".ini"}
function SAL_CONFIGFILE(name: String): String;
begin
  result:= name+'.ini';
end;

{SAL_SYSCONFIGFILE( name ) name ".ini"}
function SAL_SYSCONFIGFILE(name: String): String;
begin
  result:= name+'.ini';
end;

{SAL_CONFIGFILE( name ) name "rc"}
function SAL_CONFIGFILE_(name: String): String;
begin
  result:= name+'rc';
end;

{SAL_SYSCONFIGFILE( name ) "." name "rc"}
function SAL_SYSCONFIGFILE_(name: String): String;
begin
  result:= '.'+name+'rc';
end;

end.

