unit uno_typelib_typedescription;

interface

{$I uno_common.inc}

uses
   uno_sal_config
  ,uno_sal_types
  ,uno_typelib_typeclass
  ,uno_rtl_ustring
  ,uno_typelib_uik;

type
  p_typelib_TypeDescription = ^typelib_TypeDescription;
  pp_typelib_TypeDescription = ^p_typelib_TypeDescription;

  p_typelib_TypeDescriptionReference = ^typelib_TypeDescriptionReference;
  pp_typelib_TypeDescriptionReference = ^p_typelib_TypeDescriptionReference;

  p_typelib_CompoundTypeDescription = ^typelib_CompoundTypeDescription;
  pp_typelib_CompoundTypeDescription = ^p_typelib_CompoundTypeDescription;

  p_typelib_Union_Init = ^typelib_Union_Init;
  pp_typelib_Union_Init = ^p_typelib_Union_Init;

  p_typelib_Parameter_Init = ^typelib_Parameter_Init;
  pp_typelib_Parameter_Init = ^p_typelib_Parameter_Init;

  p_typelib_StructMember_Init = ^typelib_StructMember_Init;
  pp_typelib_StructMember_Init = ^p_typelib_StructMember_Init;

  p_typelib_CompoundMember_Init = ^typelib_CompoundMember_Init;
  pp_typelib_CompoundMember_Init = ^p_typelib_CompoundMember_Init;

  p_typelib_StructTypeDescription = ^typelib_StructTypeDescription;
  pp_typelib_StructTypeDescription = ^p_typelib_StructTypeDescription;

  p_typelib_InterfaceTypeDescription = ^typelib_InterfaceTypeDescription;
  pp_typelib_InterfaceTypeDescription = ^p_typelib_InterfaceTypeDescription;

  p_typelib_InterfaceAttributeTypeDescription = ^typelib_InterfaceAttributeTypeDescription;
  pp_typelib_InterfaceAttributeTypeDescription = ^p_typelib_InterfaceAttributeTypeDescription;

  p_typelib_InterfaceMethodTypeDescription = ^typelib_InterfaceMethodTypeDescription;
  pp_typelib_InterfaceMethodTypeDescription = ^p_typelib_InterfaceMethodTypeDescription;

  p_typelib_InterfaceMemberTypeDescription = ^typelib_InterfaceMemberTypeDescription;
  pp_typelib_InterfaceMemberTypeDescription = ^p_typelib_InterfaceMemberTypeDescription;

  p_typelib_MethodParameter = ^typelib_MethodParameter;
  pp_typelib_MethodParameter = ^p_typelib_MethodParameter;

  p_typelib_EnumTypeDescription = ^typelib_EnumTypeDescription;
  pp_typelib_EnumTypeDescription = ^p_typelib_EnumTypeDescription;

  p_typelib_ArrayTypeDescription = ^typelib_ArrayTypeDescription;
  Pp_typelib_ArrayTypeDescription = ^p_typelib_ArrayTypeDescription;

  p_typelib_IndirectTypeDescription = ^typelib_IndirectTypeDescription;
  Pp_typelib_IndirectTypeDescription = ^p_typelib_IndirectTypeDescription;

  p_typelib_UnionTypeDescription = ^typelib_UnionTypeDescription;
  Pp_typelib_UnionTypeDescription = ^p_typelib_UnionTypeDescription;

{
  Full type description of a type. Memory layout of this struct is identical
    to the typelib_TypeDescriptionReference for the first six members.
    So a typedescription can be used as type reference.
}
  _typelib_TypeDescription = record
    //   reference count; don't ever modify this by yourself, use
    //     typelib_typedescription_acquire() and typelib_typedescription_release()
    nRefCount : sal_Int32;
    //   number of static references of type, because of the fact that some types are needed
    //     until program termination and are commonly held static.
    nStaticRefCount : sal_Int32;
    //   type class of type
    eTypeClass : typelib_TypeClass;
    //   fully qualified name of type
    pTypeName : prtl_uString;
    //   pointer to self to distinguish reference from description; for internal use only
    pSelf : p_typelib_TypeDescription;
    //   pointer to optimize the runtime; not for public use
    pUniqueIdentifier : pointer;
    //   reserved for future use; 0 if not used
    pReserved : pointer;
    //   flag to determine whether the description is complete:
    //     compound and union types lack of member names, enums lack of member types and names,
    //     interfaces lack of members and table init. Call typelib_typedescription_complete() if false.
    bComplete : sal_Bool;
    //   size of type
    nSize : sal_Int32;
    //   alignment of type
    nAlignment : sal_Int32;
    //   pointer to weak reference
    pWeakRef : p_typelib_TypeDescriptionReference;
    //   determines, if type can be unloaded (and it is possible to reloaded it) 
    bOnDemand : sal_Bool;
  end;
  typelib_TypeDescription = _typelib_TypeDescription;

   // Holds a weak reference to a type description.
  _typelib_TypeDescriptionReference = record
    //   reference count of type; don't ever modify this by yourself, use
    //     typelib_typedescriptionreference_acquire() and typelib_typedescriptionreference_release()
    nRefCount : sal_Int32;
    //   number of static references of type, because of the fact that some types are needed
    //     until program termination and are commonly held static.
    nStaticRefCount : sal_Int32;
    //   type class of type
    eTypeClass : typelib_TypeClass;
    //   fully qualified name of type
    pTypeName : prtl_uString;
    //   pointer to full typedescription; this value is only valid if the type is never swapped out
    pType : p_typelib_TypeDescription;
    //   pointer to optimize the runtime; not for public use
    pUniqueIdentifier : pointer;
    //   reserved for future use; 0 if not used
    pReserved : pointer;
  end;
  typelib_TypeDescriptionReference = _typelib_TypeDescriptionReference;

  // Type description for exception types.
  _typelib_CompoundTypeDescription = record
    // inherits all members of typelib_TypeDescription
    aBase : typelib_TypeDescription;
    // pointer to base type description, else 0
    pBaseTypeDescription : p_typelib_CompoundTypeDescription;
    // number of members
    nMembers : sal_Int32;
    // byte offsets of each member including the size the base type
    pMemberOffsets : psal_Int32;
    // members of the struct or exception
    ppTypeRefs : pp_typelib_TypeDescriptionReference;
    // member names of the struct or exception 
    ppMemberNames : pprtl_uString;
  end;
  typelib_CompoundTypeDescription = _typelib_CompoundTypeDescription;

{  Type description for struct types.
     This is only used to represent plain struct types and instantiated
     polymorphic struct types; there is no representation of polymorphic struct
     type templates at this level.
     @since UDK 3.2.0     }
  _typelib_StructTypeDescription = record
    //   Derived from typelib_CompoundTypeDescription.
    aBase: typelib_CompoundTypeDescription;
    {  Flags for direct members, specifying whether they are of parameterized
       type (true) or explict type (false).
       For a plain struct type, this is a null pointer. }
    pParameterizedTypes: psal_Bool;
  end;
  typelib_StructTypeDescription = _typelib_StructTypeDescription;

  _typelib_UnionTypeDescription = record
    aBase : typelib_TypeDescription;
    pDiscriminantTypeRef : ^typelib_TypeDescriptionReference;
    nDefaultDiscriminant : sal_Int64;
    pDefaultTypeRef : p_typelib_TypeDescriptionReference;
    nMembers : sal_Int32;
    pDiscriminants : psal_Int64;
    ppTypeRefs : pp_typelib_TypeDescriptionReference;
    ppMemberNames : ^Prtl_uString;
    nValueOffset : sal_Int32;
  end;
  typelib_UnionTypeDescription = _typelib_UnionTypeDescription;

  // Type description of an array or sequence.
  _typelib_IndirectTypeDescription = record
    // inherits all members of typelib_TypeDescription
    aBase : typelib_TypeDescription;
    // array, sequence: pointer to element type
    pType : p_typelib_TypeDescriptionReference;
  end;
  typelib_IndirectTypeDescription = _typelib_IndirectTypeDescription;

  // Type description of an array.
  _typelib_ArrayTypeDescription = record
    // inherits all members of typelib_IndirectTypeDescription
    aBase : typelib_IndirectTypeDescription;
    // number of dimensions
    nDimensions : sal_Int32;
    // number of total array elements
    nTotalElements : sal_Int32;
    // array of dimensions
    pDimensions : psal_Int32;
  end;
  typelib_ArrayTypeDescription = _typelib_ArrayTypeDescription;

  _typelib_EnumTypeDescription = record
    aBase : typelib_TypeDescription;
    nDefaultEnumValue : sal_Int32;
    nEnumValues : sal_Int32;
    ppEnumNames : PPrtl_uString;
    pEnumValues : psal_Int32;
  end;
  typelib_EnumTypeDescription = _typelib_EnumTypeDescription;
  
  // Description of an interface method parameter.
  _typelib_MethodParameter = record
    //  name of parameter
    pName : prtl_uString;
    //  type of parameter
    pTypeRef : p_typelib_TypeDescriptionReference;
    //   true: the call type of this parameter is [in] or [inout]
    //  false: the call type of this parameter is [out]
    bIn : sal_Bool;
    //   true: the call type of this parameter is [out] or [inout]
    //  false: the call type of this parameter is [in]
    bOut : sal_Bool;
  end;
  typelib_MethodParameter = _typelib_MethodParameter;

{ Common base type description of typelib_InterfaceMethodTypeDescription and
    typelib_InterfaceAttributeTypeDescription.   }
  _typelib_InterfaceMemberTypeDescription = record
    //  inherits all members of typelib_TypeDescription
    aBase : typelib_TypeDescription;
    //  position of member in the interface including the number of members of any base interfaces
    nPosition : sal_Int32;
    //  name of member
    pMemberName : prtl_uString;
  end;
  typelib_InterfaceMemberTypeDescription = _typelib_InterfaceMemberTypeDescription;

{ Type description of an interface method. The type class of this description is
    typelib_TypeClass_INTERFACE_METHOD. The size and the alignment are 0. }
  _typelib_InterfaceMethodTypeDescription = record
    //  inherits all members of typelib_InterfaceMemberTypeDescription
    aBase : typelib_InterfaceMemberTypeDescription;
    //  type of the return value
    pReturnTypeRef : p_typelib_TypeDescriptionReference;
    //  number of parameters
    nParams : sal_Int32;
    //  array of parameters
    pParams : p_typelib_MethodParameter;
    //  number of exceptions
    nExceptions : sal_Int32;
    //  array of exception types
    ppExceptions : pp_typelib_TypeDescriptionReference;
    //  determines whether method is declared oneway
    bOneWay : sal_Bool;
    //  the interface description this method is a member of  @since #i21150#
    pInterface : p_typelib_InterfaceTypeDescription;
    //  the inherited direct base method (null for a method that is not inherited) @since UDK 3.2.0
    pBaseRef : p_typelib_TypeDescriptionReference;
    //  if pBaseRef is null, the member position of this method within
    //    pInterface, not counting members inherited from bases; if pBaseRef is
    //    not null, the index of the direct base within pInterface from which this
    //    method is inherited
    //    @since UDK 3.2.0
    nIndex : sal_Int32;
  end;
  typelib_InterfaceMethodTypeDescription = _typelib_InterfaceMethodTypeDescription;

{ The description of an interface attribute. The type class of this description is
    typelib_TypeClass_INTERFACE_ATTRIBUTE. The size and the alignment are 0.    }
  _typelib_InterfaceAttributeTypeDescription = record
    //  inherits all members of typelib_InterfaceMemberTypeDescription
    aBase : typelib_InterfaceMemberTypeDescription;
    //  determines whether attribute is read only
    bReadOnly : sal_Bool;
    //  type of the attribute
    pAttributeTypeRef : p_typelib_TypeDescriptionReference;
    //  the interface description this attribute is a member of  @since #i21150#
    pInterface : p_typelib_InterfaceTypeDescription;
    //  the inherited direct base attribute (null for an attribute that is not inherited) @since UDK 3.2.0
    pBaseRef : p_typelib_TypeDescriptionReference;
    //  if pBaseRef is null, the member position of this attribute within
    //    pInterface, not counting members inherited from bases; if pBaseRef is
    //    not null, the index of the direct base within pInterface from which this
    //    attribute is inherited. @since UDK 3.2.0
    nIndex : sal_Int32;
    //  number of getter exceptions. @since UDK 3.2.0
    nGetExceptions : sal_Int32;
    //  array of getter exception types. @since UDK 3.2.0
    ppGetExceptions : pp_typelib_TypeDescriptionReference;
    //  number of setter exceptions. @since UDK 3.2.0
    nSetExceptions : sal_Int32;
    //  array of setter exception types. @since UDK 3.2.0
    ppSetExceptions : pp_typelib_TypeDescriptionReference;
  end;
  typelib_InterfaceAttributeTypeDescription = _typelib_InterfaceAttributeTypeDescription;

{
    Type description of an interface.
    <p>Not all members are always initialized (not yet initialized members being
    null); there are three levels:</p>
    <ul>
        <li>Minimally, only <code>aBase</code>,
        <code>pBaseTypeDescription</code>, <code>aUik</code>,
        <code>nBaseTypes</code>, and <code>ppBaseTypes</code> are initialized;
        <code>aBase.bComplete</code> is false.  This only happens when an
        interface type description is created with
        <code>typelib_static_mi_interface_type_init</code> or
        <code>typelib_static_interface_type_init</code>.</li>

        <li>At the next level, <code>nMembers</code>, <code>ppMembers</code>,
        <code>nAllMembers</code>, <code>ppAllMembers</code> are also
        initialized; <code>aBase.bComplete</code> is still false.  This happens
        when an interface type description is created with
        <code>typelib_typedescription_newMIInterface</cocde> or
        <code>typelib_typedescription_newInterface</code>.</li>

        <li>At the final level, <code>pMapMemberIndexToFunctionIndex</code>,
        <code>nMapFunctionIndexToMemberIndex</code>, and
        <code>pMapFunctionIndexToMemberIndex</code> are also initialized;
        <code>aBase.bComplete</code> is true.  This happens after a call to
        <code>typelib_typedescription_complete</code>.</li>
    </ul>
}
  _typelib_InterfaceTypeDescription = record
    //  inherits all members of typelib_TypeDescription
    aBase : typelib_TypeDescription;
    //  pointer to base type description, else 0
    pBaseTypeDescription : p_typelib_InterfaceTypeDescription;
    //  unique identifier of interface
    aUik : typelib_Uik;
    //  number of members
    nMembers : sal_Int32;
    //  array of members; references attributes or methods
    ppMembers : pp_typelib_TypeDescriptionReference;
    //  number of members including members of base interface
    nAllMembers : sal_Int32;
    //  array of members including members of base interface; references attributes or methods
    ppAllMembers : pp_typelib_TypeDescriptionReference;
    //  array mapping index of the member description to an index doubling for read-write
    pMapMemberIndexToFunctionIndex : psal_Int32;
    //  number of members plus number of read-write attributes
    nMapFunctionIndexToMemberIndex : sal_Int32;
    //  array mapping function index to member index; size of arry is nMapFunctionIndexToMemberIndex
    pMapFunctionIndexToMemberIndex : psal_Int32;
    //  number of base types
    nBaseTypes : sal_Int32;
    //  array of base type descriptions
    ppBaseTypes : pp_typelib_InterfaceTypeDescription;
  end;
  typelib_InterfaceTypeDescription = _typelib_InterfaceTypeDescription;

  //  Init struct of compound members for typelib_typedescription_new().
  _typelib_CompoundMember_Init = record
    //  type class of compound member
    eTypeClass : typelib_TypeClass;
    //  name of type of compound member
    //    For a member of an instantiated polymorphic struct type that is of
    //    parameterized type, this will be a null pointer.
    pTypeName : prtl_uString;
    //  name of compound member
    pMemberName : prtl_uString;
  end;
  typelib_CompoundMember_Init = _typelib_CompoundMember_Init;

  _typelib_StructMember_Init = record
    aBase : typelib_CompoundMember_Init;
    bParameterizedType : sal_Bool;
  end;
  typelib_StructMember_Init = _typelib_StructMember_Init;

  _typelib_Parameter_Init = record
    eTypeClass : typelib_TypeClass;
    pTypeName : prtl_uString;
    pParamName : prtl_uString;
    bIn : sal_Bool;
    bOut : sal_Bool;
  end;
  typelib_Parameter_Init = _typelib_Parameter_Init;

  _typelib_Union_Init = record
    nDiscriminant : sal_Int64;
    pMemberName : ^rtl_uString;
    pTypeRef : ^typelib_TypeDescriptionReference;
  end;
  typelib_Union_Init = _typelib_Union_Init;


  procedure typelib_typedescription_newUnion(ppRet:Pp_typelib_TypeDescription; pTypeName:Prtl_uString; pDiscriminantTypeRef:p_typelib_TypeDescriptionReference; nDefaultDiscriminant:sal_Int64; pDefaultTypeRef:p_typelib_TypeDescriptionReference;
              nMembers:sal_Int32; pMembers: p_typelib_Union_Init); cdecl;
  procedure typelib_typedescription_newEnum(ppRet:Pp_typelib_TypeDescription; pTypeName:Prtl_uString; nDefaultValue:sal_Int32; nEnumValues:sal_Int32; ppEnumNames:PPrtl_uString;
              pEnumValues: Psal_Int32); cdecl;
  procedure typelib_typedescription_newArray(ppRet:Pp_typelib_TypeDescription; pElementTypeRef:p_typelib_TypeDescriptionReference; nDimensions:sal_Int32; pDimensions:Psal_Int32); cdecl;
  procedure typelib_typedescription_new(ppRet:Pp_typelib_TypeDescription; eTypeClass:typelib_TypeClass; pTypeName:Prtl_uString; pType:p_typelib_TypeDescriptionReference; nMembers:sal_Int32;
              pMembers:p_typelib_CompoundMember_Init); cdecl;
  procedure typelib_typedescription_newStruct(ppRet:Pp_typelib_TypeDescription; pTypeName:Prtl_uString; pType:p_typelib_TypeDescriptionReference; nMembers:sal_Int32; pMembers:p_typelib_StructMember_Init); cdecl;
  procedure typelib_typedescription_newInterface(ppRet:Pp_typelib_InterfaceTypeDescription; pTypeName:Prtl_uString; nUik1:sal_uInt32; nUik2:sal_uInt16; nUik3:sal_uInt16;
              nUik4:sal_uInt32; nUik5:sal_uInt32; pBaseInterface:p_typelib_TypeDescriptionReference; nMembers:sal_Int32; ppMembers:Pp_typelib_TypeDescriptionReference); cdecl;
  procedure typelib_typedescription_newMIInterface(ppRet:Pp_typelib_InterfaceTypeDescription; pTypeName:Prtl_uString; nUik1:sal_uInt32; nUik2:sal_uInt16; nUik3:sal_uInt16;
              nUik4:sal_uInt32; nUik5:sal_uInt32; nBaseInterfaces:sal_Int32; ppBaseInterfaces:Pp_typelib_TypeDescriptionReference; nMembers:sal_Int32;
              ppMembers:Pp_typelib_TypeDescriptionReference); cdecl;
  procedure typelib_typedescription_newInterfaceMethod(ppRet:Pp_typelib_InterfaceMethodTypeDescription; nAbsolutePosition:sal_Int32; bOneWay:sal_Bool; pMethodName:Prtl_uString; eReturnTypeClass:typelib_TypeClass;
              pReturnTypeName:Prtl_uString; nParams:sal_Int32; pParams:P_typelib_Parameter_Init; nExceptions:sal_Int32; ppExceptionNames:PPrtl_uString); cdecl;
  procedure typelib_typedescription_newInterfaceAttribute(ppRet:Pp_typelib_InterfaceAttributeTypeDescription; nAbsolutePosition:sal_Int32; pAttributeName:Prtl_uString; eAttributeTypeClass:typelib_TypeClass; pAttributeTypeName:Prtl_uString;
              bReadOnly:sal_Bool); cdecl;
  procedure typelib_typedescription_newExtendedInterfaceAttribute(ppRet:Pp_typelib_InterfaceAttributeTypeDescription; nAbsolutePosition:sal_Int32; pAttributeName:Prtl_uString; eAttributeTypeClass:typelib_TypeClass; pAttributeTypeName:Prtl_uString;
              bReadOnly:sal_Bool; nGetExceptions:sal_Int32; ppGetExceptionNames:PPrtl_uString; nSetExceptions:sal_Int32; ppSetExceptionNames:PPrtl_uString); cdecl;
  procedure typelib_typedescription_acquire(pDesc:p_typelib_TypeDescription); cdecl;
  procedure typelib_typedescription_release(pDesc:p_typelib_TypeDescription); cdecl;
  procedure typelib_typedescription_register(ppNewDescription:Pp_typelib_TypeDescription); cdecl;
  function typelib_typedescription_equals(p1:p_typelib_TypeDescription; p2:p_typelib_TypeDescription): sal_Bool; cdecl;
  procedure typelib_typedescription_getByName(var pRet: p_typelib_TypeDescription; pName:Prtl_uString); cdecl;
  procedure typelib_setCacheSize(nNewSize:sal_Int32); cdecl;

type
  typelib_typedescription_Callback = procedure (pContext:pointer; ppRet:Pp_typelib_TypeDescription; pTypeName:Prtl_uString); cdecl;

  procedure typelib_typedescription_registerCallback(pContext:pointer; pCallback:typelib_typedescription_Callback); cdecl;
  procedure typelib_typedescription_revokeCallback(pContext:pointer; pCallback:typelib_typedescription_Callback); cdecl;

{ Creates a type description reference. This is a weak reference not holding the description.
    If the description is already registered, the previous one is returned.
  @param ppTDR inout type description reference
  @param eTypeClass type class of type
  @param pTypeName name of type   }
  procedure typelib_typedescriptionreference_new( var pTDR: p_typelib_TypeDescriptionReference;
                                                 eTypeClass: typelib_TypeClass;
                                                  pTypeName: prtl_uString); cdecl;

{ Creates a type description reference. This is a weak reference not holding the description.
  If the description is already registered, the previous one is returned.
    
  @param ppTDR inout type description reference
  @param eTypeClass type class of type
  @param pTypeName ascii name of type }
  procedure typelib_typedescriptionreference_newByAsciiName( var pTDR: p_typelib_TypeDescriptionReference;
                                                            eTypeClass: typelib_TypeClass;
                                                             pTypeName: psal_Char); cdecl;

  procedure typelib_typedescriptionreference_acquire(pRef:p_typelib_TypeDescriptionReference); cdecl;
  procedure typelib_typedescriptionreference_release(pRef:p_typelib_TypeDescriptionReference); cdecl;
  procedure typelib_typedescriptionreference_getDescription(var pRet: p_typelib_TypeDescription; pRef:p_typelib_TypeDescriptionReference); cdecl;
  function typelib_typedescriptionreference_equals(p1:p_typelib_TypeDescriptionReference; p2:p_typelib_TypeDescriptionReference):sal_Bool; cdecl;
  procedure typelib_typedescriptionreference_assign(ppDest:Pp_typelib_TypeDescriptionReference; pSource:p_typelib_TypeDescriptionReference); cdecl;
  function typelib_typedescription_isAssignableFrom(pAssignable:p_typelib_TypeDescription; pFrom:p_typelib_TypeDescription):sal_Bool; cdecl;
  function typelib_typedescriptionreference_isAssignableFrom(pAssignable:p_typelib_TypeDescriptionReference; pFrom:p_typelib_TypeDescriptionReference):sal_Bool; cdecl;
  function typelib_static_type_getByTypeClass(eTypeClass:typelib_TypeClass):Pp_typelib_TypeDescriptionReference; cdecl;
  procedure typelib_static_type_init(ppRef:Pp_typelib_TypeDescriptionReference; eTypeClass:typelib_TypeClass; pTypeName:Psal_Char); cdecl;
  procedure typelib_static_sequence_type_init( var pRef: p_typelib_TypeDescriptionReference; pElementType:p_typelib_TypeDescriptionReference); cdecl;
  procedure typelib_static_array_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pElementType:p_typelib_TypeDescriptionReference; nDimensions:sal_Int32; args:array of const); cdecl;
  procedure typelib_static_compound_type_init(ppRef:Pp_typelib_TypeDescriptionReference; eTypeClass:typelib_TypeClass; pTypeName:Psal_Char; pBaseType:p_typelib_TypeDescriptionReference; nMembers:sal_Int32;
              ppMembers:Pp_typelib_TypeDescriptionReference); cdecl;
  procedure typelib_static_struct_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; pBaseType:p_typelib_TypeDescriptionReference; nMembers:sal_Int32; ppMembers:Pp_typelib_TypeDescriptionReference;
              pParameterizedTypes:Psal_Bool); cdecl;
  procedure typelib_static_interface_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; pBaseType:p_typelib_TypeDescriptionReference); cdecl;
  procedure typelib_static_mi_interface_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; nBaseTypes:sal_Int32; ppBaseTypes:Pp_typelib_TypeDescriptionReference); cdecl;
  procedure typelib_static_enum_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; nDefaultValue:sal_Int32); cdecl;
  procedure typelib_static_union_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; pDiscriminantType:p_typelib_TypeDescriptionReference; nDefaultDiscriminant:sal_Int64; pDefaultType:p_typelib_TypeDescriptionReference;
              nMembers:sal_Int32; pDiscriminants: Psal_Int64; pMemberTypes:Pp_typelib_TypeDescriptionReference); cdecl;
  function typelib_typedescription_complete(ppTypeDescr: pp_typelib_TypeDescription):sal_Bool; cdecl;

  //
  procedure TYPELIB_DANGER_RELEASE( pDescription: p_typelib_TypeDescription );
  procedure TYPELIB_DANGER_GET( var pDescription: p_typelib_TypeDescription;
                                        pTypeRef: p_typelib_TypeDescriptionReference );
  function TYPELIB_TYPEDESCRIPTIONREFERENCE_ISREALLYWEAK( eTypeClass: typelib_TypeClass ): Boolean;

implementation

  procedure typelib_typedescription_newUnion(ppRet:Pp_typelib_TypeDescription; pTypeName:Prtl_uString; pDiscriminantTypeRef:p_typelib_TypeDescriptionReference; nDefaultDiscriminant:sal_Int64; pDefaultTypeRef:p_typelib_TypeDescriptionReference;
              nMembers:sal_Int32; pMembers:p_typelib_Union_Init); external cppu3LibraryName;
  procedure typelib_typedescription_newEnum(ppRet:Pp_typelib_TypeDescription; pTypeName:Prtl_uString; nDefaultValue:sal_Int32; nEnumValues:sal_Int32; ppEnumNames:PPrtl_uString;
              pEnumValues:Psal_Int32); external cppu3LibraryName;
  procedure typelib_typedescription_newArray(ppRet:Pp_typelib_TypeDescription; pElementTypeRef:p_typelib_TypeDescriptionReference; nDimensions:sal_Int32; pDimensions:Psal_Int32); external cppu3LibraryName;
  procedure typelib_typedescription_new(ppRet:Pp_typelib_TypeDescription; eTypeClass:typelib_TypeClass; pTypeName:Prtl_uString; pType:p_typelib_TypeDescriptionReference; nMembers:sal_Int32;
              pMembers:p_typelib_CompoundMember_Init); external cppu3LibraryName;
  procedure typelib_typedescription_newStruct(ppRet:Pp_typelib_TypeDescription; pTypeName:Prtl_uString; pType:p_typelib_TypeDescriptionReference; nMembers:sal_Int32; pMembers:p_typelib_StructMember_Init); external cppu3LibraryName;
  procedure typelib_typedescription_newInterface(ppRet:Pp_typelib_InterfaceTypeDescription; pTypeName:Prtl_uString; nUik1:sal_uInt32; nUik2:sal_uInt16; nUik3:sal_uInt16;
              nUik4:sal_uInt32; nUik5:sal_uInt32; pBaseInterface:p_typelib_TypeDescriptionReference; nMembers:sal_Int32; ppMembers:Pp_typelib_TypeDescriptionReference); external cppu3LibraryName;
  procedure typelib_typedescription_newMIInterface(ppRet:Pp_typelib_InterfaceTypeDescription; pTypeName:Prtl_uString; nUik1:sal_uInt32; nUik2:sal_uInt16; nUik3:sal_uInt16;
              nUik4:sal_uInt32; nUik5:sal_uInt32; nBaseInterfaces:sal_Int32; ppBaseInterfaces:Pp_typelib_TypeDescriptionReference; nMembers:sal_Int32;
              ppMembers:Pp_typelib_TypeDescriptionReference); external cppu3LibraryName;
  procedure typelib_typedescription_newInterfaceMethod(ppRet:Pp_typelib_InterfaceMethodTypeDescription; nAbsolutePosition:sal_Int32; bOneWay:sal_Bool; pMethodName:Prtl_uString; eReturnTypeClass:typelib_TypeClass;
              pReturnTypeName:Prtl_uString; nParams:sal_Int32; pParams:P_typelib_Parameter_Init; nExceptions:sal_Int32; ppExceptionNames:PPrtl_uString); external cppu3LibraryName;
  procedure typelib_typedescription_newInterfaceAttribute(ppRet:Pp_typelib_InterfaceAttributeTypeDescription; nAbsolutePosition:sal_Int32; pAttributeName:Prtl_uString; eAttributeTypeClass:typelib_TypeClass; pAttributeTypeName:Prtl_uString;
              bReadOnly:sal_Bool); external cppu3LibraryName;
  procedure typelib_typedescription_newExtendedInterfaceAttribute(ppRet:Pp_typelib_InterfaceAttributeTypeDescription; nAbsolutePosition:sal_Int32; pAttributeName:Prtl_uString; eAttributeTypeClass:typelib_TypeClass; pAttributeTypeName:Prtl_uString;
              bReadOnly:sal_Bool; nGetExceptions:sal_Int32; ppGetExceptionNames:PPrtl_uString; nSetExceptions:sal_Int32; ppSetExceptionNames:PPrtl_uString); external cppu3LibraryName;
  procedure typelib_typedescription_acquire(pDesc: p_typelib_TypeDescription); external cppu3LibraryName;
  procedure typelib_typedescription_release(pDesc: p_typelib_TypeDescription); external cppu3LibraryName;
  procedure typelib_typedescription_register(ppNewDescription:Pp_typelib_TypeDescription); external cppu3LibraryName;
  function typelib_typedescription_equals(p1:p_typelib_TypeDescription; p2:p_typelib_TypeDescription): sal_Bool; external cppu3LibraryName;
  procedure typelib_typedescription_getByName(var pRet: p_typelib_TypeDescription; pName:Prtl_uString); external cppu3LibraryName;
  procedure typelib_setCacheSize(nNewSize:sal_Int32); external cppu3LibraryName;
  procedure typelib_typedescription_registerCallback(pContext:pointer; pCallback:typelib_typedescription_Callback); external cppu3LibraryName;
  procedure typelib_typedescription_revokeCallback(pContext:pointer; pCallback:typelib_typedescription_Callback); external cppu3LibraryName;

  procedure typelib_typedescriptionreference_new( var pTDR: p_typelib_TypeDescriptionReference; eTypeClass: typelib_TypeClass; pTypeName: prtl_uString); external cppu3LibraryName;
  procedure typelib_typedescriptionreference_newByAsciiName( var pTDR: p_typelib_TypeDescriptionReference; eTypeClass: typelib_TypeClass; pTypeName: psal_Char); external cppu3LibraryName;

  procedure typelib_typedescriptionreference_acquire(pRef:p_typelib_TypeDescriptionReference); external cppu3LibraryName;
  procedure typelib_typedescriptionreference_release(pRef:p_typelib_TypeDescriptionReference); external cppu3LibraryName;
  procedure typelib_typedescriptionreference_getDescription( var pRet: p_typelib_TypeDescription; pRef:p_typelib_TypeDescriptionReference); external cppu3LibraryName;
  function typelib_typedescriptionreference_equals(p1:p_typelib_TypeDescriptionReference; p2:p_typelib_TypeDescriptionReference):sal_Bool; external cppu3LibraryName;
  procedure typelib_typedescriptionreference_assign(ppDest:Pp_typelib_TypeDescriptionReference; pSource:p_typelib_TypeDescriptionReference); external cppu3LibraryName;
  function typelib_typedescription_isAssignableFrom(pAssignable:p_typelib_TypeDescription; pFrom:p_typelib_TypeDescription):sal_Bool; external cppu3LibraryName;
  function typelib_typedescriptionreference_isAssignableFrom(pAssignable:p_typelib_TypeDescriptionReference; pFrom:p_typelib_TypeDescriptionReference):sal_Bool; external cppu3LibraryName;
  function typelib_static_type_getByTypeClass(eTypeClass:typelib_TypeClass):Pp_typelib_TypeDescriptionReference; external cppu3LibraryName;
  procedure typelib_static_type_init(ppRef:Pp_typelib_TypeDescriptionReference; eTypeClass:typelib_TypeClass; pTypeName:Psal_Char); external cppu3LibraryName;
  procedure typelib_static_sequence_type_init( var pRef: p_typelib_TypeDescriptionReference; pElementType:p_typelib_TypeDescriptionReference); external cppu3LibraryName;
  procedure typelib_static_array_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pElementType:p_typelib_TypeDescriptionReference; nDimensions:sal_Int32; args:array of const); external cppu3LibraryName;
  procedure typelib_static_compound_type_init(ppRef:Pp_typelib_TypeDescriptionReference; eTypeClass:typelib_TypeClass; pTypeName:Psal_Char; pBaseType:p_typelib_TypeDescriptionReference; nMembers:sal_Int32;
              ppMembers:Pp_typelib_TypeDescriptionReference); external cppu3LibraryName;
  procedure typelib_static_struct_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; pBaseType:p_typelib_TypeDescriptionReference; nMembers:sal_Int32; ppMembers:Pp_typelib_TypeDescriptionReference;
              pParameterizedTypes:Psal_Bool); external cppu3LibraryName;
  procedure typelib_static_interface_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; pBaseType:p_typelib_TypeDescriptionReference); external cppu3LibraryName;
  procedure typelib_static_mi_interface_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; nBaseTypes:sal_Int32; ppBaseTypes:Pp_typelib_TypeDescriptionReference); external cppu3LibraryName;
  procedure typelib_static_enum_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; nDefaultValue:sal_Int32); external cppu3LibraryName;
  procedure typelib_static_union_type_init(ppRef:Pp_typelib_TypeDescriptionReference; pTypeName:Psal_Char; pDiscriminantType:p_typelib_TypeDescriptionReference; nDefaultDiscriminant:sal_Int64; pDefaultType:p_typelib_TypeDescriptionReference;
              nMembers:sal_Int32; pDiscriminants:Psal_Int64; pMemberTypes:Pp_typelib_TypeDescriptionReference); external cppu3LibraryName;
  function typelib_typedescription_complete(ppTypeDescr: pp_typelib_TypeDescription):sal_Bool; external cppu3LibraryName;

//==============================================================================
//             Macros
//==============================================================================
function TYPELIB_TYPEDESCRIPTIONREFERENCE_ISREALLYWEAK( eTypeClass: typelib_TypeClass ): Boolean;
begin
  Result:=(eTypeClass = typelib_TypeClass_INTERFACE_METHOD) or
          (eTypeClass = typelib_TypeClass_INTERFACE_ATTRIBUTE);
end;

{ Gets a description from the reference. The description may not be locked by this call.
    You must use the TYPELIB_DANGER_RELEASE macro to release the description fetched with
    this macro.
    @internal}
procedure TYPELIB_DANGER_GET( var pDescription: p_typelib_TypeDescription;
                                      pTypeRef: p_typelib_TypeDescriptionReference );
begin
  pDescription:=nil;
  if (TYPELIB_TYPEDESCRIPTIONREFERENCE_ISREALLYWEAK( pTypeRef^.eTypeClass )) then
    typelib_typedescriptionreference_getDescription( pDescription, pTypeRef )
  else if ( not Assigned(pTypeRef.pType) ) or ( not Assigned(pTypeRef.pType.pWeakRef) ) then begin
    typelib_typedescriptionreference_getDescription( pDescription, pTypeRef );
    if Assigned(pDescription) then
      typelib_typedescription_release( pDescription );
  end else
    pDescription:=pTypeRef.pType;
end;

{ Releases the description previouse fetched by TYPELIB_DANGER_GET.
    @internal }
procedure TYPELIB_DANGER_RELEASE( pDescription: p_typelib_TypeDescription );
begin
  if TYPELIB_TYPEDESCRIPTIONREFERENCE_ISREALLYWEAK( pDescription^.eTypeClass ) then
    typelib_typedescription_release( pDescription );
end;

end.